//-----------------------------------------------------------------------------
// NOTE : CBoss Ŭ  
//  :   Ŭ
// ϸ : CBoss.cpp
// 2004.8.27	ora_llundiov
//-----------------------------------------------------------------------------


#include "CBoss.h"
#include "math.h"

//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CBoss::CBoss()
{
	m_nStage		= 0;
	m_dwMove		= 0;
	m_bExt			= FALSE;
} 


CBoss::~CBoss()
 {

 }


//-----------------------------------------------------------------------------
 // ʱȭ Լ
//-----------------------------------------------------------------------------
void CBoss::Create(LPDIRECTDRAW7 *pDD, CForces *pForces, CDxMusic *pMusic,
				   CDirectShow *pDShow)
{
	m_pDD = *pDD;
	m_pForces = pForces;
	m_pMusic = pMusic;
	m_pDShow = pDShow;
}





//-----------------------------------------------------------------------------
 // ʱⰪ
//-----------------------------------------------------------------------------
void CBoss::InitBoss()
{
	// 
	BOSS_LIST::iterator itorBoss;
	for (itorBoss = m_listBoss.begin(); itorBoss != m_listBoss.end(); ++itorBoss)
	{
		delete (*itorBoss);
	}

	m_listBoss.clear();
}




//-----------------------------------------------------------------------------
 // ʱⰪ
//-----------------------------------------------------------------------------
void CBoss::LoadBoss(int nStage)
{
	//  ۾
	ReleaseBoss();

	switch (nStage)
	{
	case 1:
		LoadOnlySprData("spr\\boss_1.spr", (ONLY_SPRITE*)&m_osBoss[0]);
		CreateSurfaceFromBitmap(&m_psurBoss[0], "image\\boss_1.ora", NULL, NULL);
		m_psurBoss[0]->SetColorKey(RGB(0, 255, 0));

		// 
		LoadOnlySprData("spr\\boss_enege.spr", (ONLY_SPRITE*)&m_osEnege);
		CreateSurfaceFromBitmap(&m_psurEnege, "image\\boss_enege.ora", NULL, NULL);
		m_psurEnege->SetColorKey(RGB(0, 255, 0));
	
		break;

	case 2:
		LoadOnlySprData("spr\\boss_2.spr", (ONLY_SPRITE*)&m_osBoss[0]);
		CreateSurfaceFromBitmap(&m_psurBoss[0], "image\\boss_2.ora", NULL, NULL);
		m_psurBoss[0]->SetColorKey(RGB(0, 0, 0));

		// 
		LoadOnlySprData("spr\\boss_enege.spr", (ONLY_SPRITE*)&m_osEnege);
		CreateSurfaceFromBitmap(&m_psurEnege, "image\\boss_enege.ora", NULL, NULL);
		m_psurEnege->SetColorKey(RGB(0, 255, 0));
		break;

	case 3:
		LoadOnlySprData("spr\\boss_3.spr", (ONLY_SPRITE*)&m_osBoss[0]);
		LoadOnlySprData("spr\\boss_4.spr", (ONLY_SPRITE*)&m_osBoss[1]);
		LoadOnlySprData("spr\\boss_5.spr", (ONLY_SPRITE*)&m_osBoss[2]);
		CreateSurfaceFromBitmap(&m_psurBoss[0], "image\\boss_3.ora", NULL, NULL);
		CreateSurfaceFromBitmap(&m_psurBoss[1], "image\\boss_4.ora", NULL, NULL);
		CreateSurfaceFromBitmap(&m_psurBoss[2], "image\\boss_5.ora", NULL, NULL);
		m_psurBoss[0]->SetColorKey(RGB(0, 255, 0));
		m_psurBoss[1]->SetColorKey(RGB(0, 255, 0));
		m_psurBoss[2]->SetColorKey(RGB(0, 255, 0));

		// 
		LoadOnlySprData("spr\\boss_enege.spr", (ONLY_SPRITE*)&m_osEnege);
		CreateSurfaceFromBitmap(&m_psurEnege, "image\\boss_enege.ora", NULL, NULL);
		m_psurEnege->SetColorKey(RGB(0, 255, 0));
		break;

	}

	m_bExt = FALSE;
}



//-----------------------------------------------------------------------------
 // ʱⰪ
//-----------------------------------------------------------------------------
void CBoss::ReleaseBoss()
{
	if (m_psurBoss[0]) m_psurBoss[0]->Destroy();
	if (m_psurBoss[1]) m_psurBoss[1]->Destroy();
	if (m_psurBoss[2]) m_psurBoss[2]->Destroy();
	if (m_psurEnege) m_psurEnege->Destroy();
	
	DestroyLOSD(&m_osBoss[0]);
	DestroyLOSD(&m_osBoss[1]);
	DestroyLOSD(&m_osBoss[2]);
	DestroyLOSD(&m_osEnege);

	m_psurBoss[0] = NULL;
	m_psurBoss[1] = NULL;
	m_psurBoss[2] = NULL;
	m_psurEnege   = NULL;
}


//-----------------------------------------------------------------------------
//  ߰
// nBoss : 
// nOpt : ɼ 1
// nOpt2 : ɼ 2
// x : xǥ
// y : yǥ
//-----------------------------------------------------------------------------
void CBoss::AddBoss(int nBoss, int nOpt, int nOpt2, int x, int y)
{
	BOSS *add;
	add = new BOSS;

	if (add == NULL)
		return;
	
	add->ptPos.x = x;
	add->ptPos.y = -y;

	add->nShip	 = nBoss;
	add->nState	 = B_NORMAL;
	add->nMove 	 = M_CREATE;
	add->nLife	 = 2000;
	if (m_nStage == 2)
		add->nLife	 = 3200;
	add->nMoveX	 = 0.;
	add->nMoveY	 = 3.;
	add->nAcc  	 = 0.;
	add->nDrawBoss = 0;
	add->dwDealy = 300;
	add->nOpt	 = nOpt;
	add->nOpt2	 = nOpt2;

	add->ptEnege.x = 50;
	add->ptEnege.y = 5;

	if (nOpt == 1)
	{
		add->nLife	 = 1200;
		if (nOpt2 == 1)
			add->ptEnege.y = 20;
		else
			add->ptEnege.y = 35;
	}
	else if (nOpt == 2)
	{
		add->nLife	 = 800;
		add->nMoveY	 = 6.;
		add->ptEnege.y = 50;
	}

	add->dwCreateTime = timeGetTime();
	

	m_listBoss.push_back(add);

	if (nOpt == 0)
		m_pForces->SetSay(3);
}




//-----------------------------------------------------------------------------
//   Ʈ
//-----------------------------------------------------------------------------
void CBoss::UpdateBoss(CBoom *pBoom, CBullet *pBullet)
{
	BOSS_LIST::iterator itor;
	BOSS_LIST::iterator del[20];

	int index = -1;
	int size[4] = {0, 40, -40, 0};
	POINT ptPos[5] = { {100, 100}, {450, 90}, {400, 150}, {300, 100}, {150, 160} };

	for (itor = m_listBoss.begin(); itor != m_listBoss.end(); ++itor)
	{
		switch (m_nStage)
		{
		case 1: //  2
			//  
			switch ((*itor)->nState)
			{
			case B_NORMAL:
				(*itor)->nDrawBoss = !(*itor)->nDrawBoss;
				break;

			case B_WARNING:
				(*itor)->nDrawBoss = 2;
				(*itor)->nState = B_NORMAL;
				break;
			}

			//  
			switch ((*itor)->nMove)
			{
			case M_CREATE:
				if ((*itor)->ptPos.y > 170)
				{
					(*itor)->nMove = M_MOVE1;
					(*itor)->nMoveY = 0.;
					(*itor)->nMoveX = 1.;
					m_nCount = 0;
					m_dwDealy = timeGetTime();
					m_ptTemp.x = (*itor)->ptPos.x;
					m_ptTemp.y = (*itor)->ptPos.y;
					m_nPos = 0;
				}
				break;

			case M_MOVE1:
				if ((m_nPos += 2) > 60) m_nPos = 1;

				if ((m_ptTemp.x += (int)(*itor)->nMoveX) > 500)
				{
					(*itor)->nMoveX = -1.;
				}
				else if ((m_ptTemp.x += (int)(*itor)->nMoveX) < 100)
				{
					(*itor)->nMoveX = 1.;
				}

				(*itor)->ptPos.x = (int)(m_ptTemp.x + 50 * sin((m_nPos * 6) * PI / 180));
				(*itor)->ptPos.y = (int)(m_ptTemp.y - 50 * cos((m_nPos * 6) * PI / 180));

				// Ѿ ߰
				if ((timeGetTime() - m_dwDealy) >= 400)
				{
					pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y + 30, 2, 0);
					m_dwDealy = timeGetTime();
					m_nCount++;
				}

				if (m_nCount == 20)
				{
					(*itor)->nMove  = M_MOVE2;
					(*itor)->nMoveX = 0.;
					m_dwDealy = timeGetTime();
					m_nCount  = 0;
				}
				break;

			case M_MOVE2:
				// Ѿ ߰
				if ((timeGetTime() - m_dwDealy) >= 300)
				{
					pBullet->AddBullet((*itor)->ptPos.x + size[m_nCount], (*itor)->ptPos.y + 30, 2, 3);
					m_dwDealy = timeGetTime();
					m_nCount++;
				}

				if (m_nCount == 4)
				{
					(*itor)->nMove  = M_MOVE1;
					(*itor)->nMoveX = 1.;
					m_nCount  = 0;
					m_dwDealy = timeGetTime();
				}
				break;
			}
			break;
//--------------------------------------------------------------------------

		case 0: //  1 
			//  
			switch ((*itor)->nState)
			{
			case B_NORMAL:
				(*itor)->nDrawBoss = !(*itor)->nDrawBoss;
				break;

			case B_WARNING:
				(*itor)->nDrawBoss = 2;
				(*itor)->nState = B_NORMAL;
				break;
			}

			//  
			switch ((*itor)->nMove)
			{
			case M_CREATE:
				if ((*itor)->ptPos.y > 170)
				{
					(*itor)->nMove = M_MOVE1;
					(*itor)->nMoveY = 0.;
					(*itor)->nMoveX = 0.;
					m_nCount = 0;
					m_dwDealy = timeGetTime();
				}
				break;

			case M_MOVE1:
				// Ѿ ߰
				if ((timeGetTime() - m_dwDealy) >= 300)
				{
					pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 4, 0);
					m_dwDealy = timeGetTime();
				}

				if ((*itor)->ptPos.x > 500)
				{
					(*itor)->nMoveX = -1.;
					(*itor)->ptPos.x = 500;
					m_nCount++;
				}
				if ((*itor)->ptPos.x < 100)
				{
					(*itor)->nMoveX = 1.;
					(*itor)->ptPos.x = 100;
					m_nCount++;
				}
				
				if ((*itor)->nMoveX > 0)
					(*itor)->nMoveX += 0.5;
				else
					(*itor)->nMoveX -= 0.5;

				if (m_nCount >= ((rand() % 4) + 3) )
				{
					if ((*itor)->ptPos.x > 250 && (*itor)->ptPos.x < 350)
					{
						(*itor)->nMove = M_MOVE2;
						(*itor)->nMoveX = 0.;
						(*itor)->nMoveY = 0.;
						m_nCount = 0;
						m_nBullet = 0;
						m_dwDealy = timeGetTime();
						(*itor)->ptPos.x = ptPos[0].x;
						(*itor)->ptPos.y = ptPos[0].y;
					}
				}
				break;

			case M_MOVE2:
				// Ѿ ߰
				if ((timeGetTime() - m_dwDealy) >= 300)
				{
					pBullet->AddBullet((*itor)->ptPos.x + size[m_nBullet], (*itor)->ptPos.y + 30, 2, 3);
					m_dwDealy = timeGetTime();
					if (++m_nBullet > 4)
					{
						m_nCount++;
						m_nBullet = 0;
						(*itor)->ptPos.x = ptPos[m_nCount].x;
						(*itor)->ptPos.y = ptPos[m_nCount].y;

					}
				}

				if (m_nCount == 4)
				{
					(*itor)->nMove  = M_MOVE1;
					(*itor)->nMoveX = 1.;
					m_nCount  = 0;
					m_dwDealy = timeGetTime();
				}
				break;
			}
			break;
//----------------------------------------------------------------------------

		case 2: //  3 
			//  
			switch ((*itor)->nState)
			{
			case B_NORMAL:
				(*itor)->nDrawBoss = !(*itor)->nDrawBoss;
				break;

			case B_WARNING:
				(*itor)->nDrawBoss = 2;
				(*itor)->nState = B_NORMAL;
				break;
			}

			//  
			switch ((*itor)->nOpt)
			{
			case 0: // ߰
				//------------------------------
				switch ((*itor)->nMove)
				{
				case M_CREATE:
					if ((*itor)->ptPos.y > 140)
					{
						(*itor)->nMove = M_MOVE1;
						(*itor)->nMoveY = 0.;
						(*itor)->nMoveX = 1.;
						m_nCount = 0;
						m_dwDealy = timeGetTime();
					}
					break;

				case M_MOVE1:

					// Ѿ ߰
					if ((timeGetTime() - m_dwDealy) >= 1000)
					{
						pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 2, 2);
						m_dwDealy = timeGetTime();
					}

					if ((*itor)->ptPos.x > 400)
					{
						(*itor)->nMoveX = -1.;
						(*itor)->ptPos.x = 400;
						m_nCount++;
					}
					if ((*itor)->ptPos.x < 200)
					{
						(*itor)->nMoveX = 1.;
						(*itor)->ptPos.x = 200;
						m_nCount++;
					}
					
					if ((*itor)->nMoveX > 0)
						(*itor)->nMoveX += 0.1;
					else
						(*itor)->nMoveX -= 0.1;

					break;
				}//-----------------------------
				break; // case 0;

			case 1: // ̵ 
				//------------------------------
				switch ((*itor)->nMove)
				{
				case M_CREATE:
					if ((*itor)->ptPos.y > 150)
					{
						(*itor)->nMove = M_MOVE1;
						(*itor)->nMoveY = 0.;
						(*itor)->nMoveX = 0.;
						m_nCount = 0;
						m_dwDealy = timeGetTime();
						if ((*itor)->nOpt2 == 1)
							m_nPos2[0] = 60;
						if ((*itor)->nOpt2 == 2)
							m_nPos2[1] = 0;
						(*itor)->dwDealy = timeGetTime();
					}
					break;

				case M_MOVE1:
					// Ѿ ߰
					if ((timeGetTime() - (*itor)->dwDealy) >= 500)
					{
						pBullet->AddBullet((*itor)->ptPos.x, (*itor)->ptPos.y, 2, 0);
						(*itor)->dwDealy = timeGetTime();
				
					}

					(*itor)->ptPos.x = (int)(m_ptTemp2[(*itor)->nOpt2-1].x + 60 * sin((m_nPos2[(*itor)->nOpt2-1] * 6) * PI / 180));
					(*itor)->ptPos.y = (int)(m_ptTemp2[(*itor)->nOpt2-1].y - 60 * cos((m_nPos2[(*itor)->nOpt2-1] * 6) * PI / 180));
					
					if ((*itor)->nOpt2 == 1)
					{
						if ((m_nPos2[0] -= 2) < 0)
							m_nPos2[0] = 60;
					}
					if ((*itor)->nOpt2 == 2)
					{
						if ((m_nPos2[1] += 2) > 60)
							m_nPos2[1] = 0;
					}
					break;
				}//------------------------------
				break; // case 1;

			case 2:
				//------------------------------
				switch ((*itor)->nMove)
				{
				case M_CREATE:
					if ((*itor)->ptPos.y > 280)
					{
						(*itor)->nMove = M_MOVE1;
						(*itor)->nMoveY = 0.;
						(*itor)->nMoveX = 0.;
						m_nCount = 0;
						(*itor)->dwDealy = timeGetTime();
					}
					break;

				case M_MOVE1:
					if ((timeGetTime() - (*itor)->dwDealy) >= 5000)
					{
						(*itor)->nMove = M_MOVE2;
						(*itor)->nMoveX = 0.;
						(*itor)->nMoveY = 1.;

					}
					(*itor)->ptPos.x = m_ptTemp2[2].x;
					(*itor)->ptPos.y = m_ptTemp2[2].y - 50;
					break;

				case M_MOVE2:
					if ((*itor)->nMoveY > 0)
						(*itor)->nMoveY += 4.;
					else
						(*itor)->nMoveY -= 4.;

					if ((*itor)->ptPos.y > 500)
						(*itor)->nMoveY = -1.;

					(*itor)->nMoveX += (rand() % 4) * (rand() % 2 ? 1 : -1);

					if ((*itor)->ptPos.y <= 150)
					{
						(*itor)->nMove = M_MOVE1;
						(*itor)->nMoveX = 0.;
						(*itor)->nMoveY = 0.;
						(*itor)->ptPos.x = m_ptTemp2[2].x;
						(*itor)->ptPos.y = m_ptTemp2[2].y;
						(*itor)->dwDealy = timeGetTime();
					}
					break;
				}//------------------------------
				break; // case 2;
			}
			
			break;
		}
//--------------------------------------------------------------------------------

		(*itor)->ptPos.x += (int)(*itor)->nMoveX;
		(*itor)->ptPos.y += (int)(*itor)->nMoveY;

		if ((m_nStage == 2) && ((*itor)->nOpt == 0))
		{
			//if (m_bExt == FALSE)
			//{
				m_ptTemp2[0].x = (*itor)->ptPos.x - 150;
				m_ptTemp2[0].y = (*itor)->ptPos.y;
				m_ptTemp2[1].x = (*itor)->ptPos.x + 150;
				m_ptTemp2[1].y = (*itor)->ptPos.y;
				m_ptTemp2[2].x = (*itor)->ptPos.x;
				m_ptTemp2[2].y = (*itor)->ptPos.y + 150;
			//}
		}

		if (m_bExt == TRUE)
			{
				m_ptTemp2[0].x += m_movex;
				m_ptTemp2[1].x += m_movex; 

				if (m_ptTemp2[1].x > 500)
				{
					m_movex = -1;
				}
				else if (m_ptTemp2[0].x < 100)
				{
					m_movex = 1;
				}
			}


		//  üũ
		if ((*itor)->nLife <= 0)
		{
			// 
			m_pMusic->PlaySound(7, FALSE);
			m_pMusic->PlaySound(6, FALSE);
			m_pMusic->PlaySound(5, FALSE);
			
			del[++index] = itor;
			pBoom->Add(2, (*itor)->ptPos.x, (*itor)->ptPos.y);
			pBoom->Add(0, (*itor)->ptPos.x - 20, (*itor)->ptPos.y - 20);
			pBoom->Add(0, (*itor)->ptPos.x + 20, (*itor)->ptPos.y + 20);
			pBoom->Add(1, (*itor)->ptPos.x + 40, (*itor)->ptPos.y - 40);
			pBoom->Add(1, (*itor)->ptPos.x - 40, (*itor)->ptPos.y + 40);

			if ((m_nStage == 2) && ((*itor)->nOpt == 0))
			{
				m_bExt = TRUE;
				m_movex = 2;
			}

			m_pForces->SetScore(1000);

		}
	}

	 // 
	for (int i = 0; i <= index; i++)
	{
		delete (*del[i]);
		m_listBoss.erase(del[i]);

		if (m_listBoss.size() == 0)
		{
			m_pForces->SetStateFish(F_CLEAR);
			m_pForces->SetMujuc(FALSE);
			m_pForces->SetClearDealy(timeGetTime());
			m_pForces->SetDrawClear(TRUE);

			// Ŭ 
			m_pDShow->Stop();
			m_pMusic->PlaySound(15, FALSE);
		}
	}
}





//-----------------------------------------------------------------------------
//  Լ 
//------------------------------------------------------------------------------
void CBoss::Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB, CBoom *pBoom, CBullet *pBullet)
{
	// 
	//UpdateBoss(pBoom, pBullet);

	// 
	BOSS_LIST::iterator itor;
	RECT rtDraw;
	RECT rtSprite;

	for (itor = m_listBoss.begin(); itor != m_listBoss.end(); ++itor)
	{
		MakeCenterToRect(&m_osBoss[0 + (*itor)->nOpt].pSpr[(*itor)->nDrawBoss].ptSprCenterPos,
						 &m_osBoss[0 + (*itor)->nOpt].pSpr[(*itor)->nDrawBoss].rcSprPos,
						 &((*itor)->ptPos),
						 &rtDraw);

		rtSprite.left	= m_osBoss[0 + (*itor)->nOpt].pSpr[(*itor)->nDrawBoss].rcSprPos.left;
		rtSprite.top	= m_osBoss[0 + (*itor)->nOpt].pSpr[(*itor)->nDrawBoss].rcSprPos.top;
		rtSprite.right	= m_osBoss[0 + (*itor)->nOpt].pSpr[(*itor)->nDrawBoss].rcSprPos.right;
		rtSprite.bottom = m_osBoss[0 + (*itor)->nOpt].pSpr[(*itor)->nDrawBoss].rcSprPos.bottom;
		
		//  Ų 
		if (rtDraw.left < 0)
		{
			rtSprite.left += (-rtDraw.left);
			rtDraw.left = 0;
		}
		if (rtDraw.right > 600)
		{
			rtSprite.right -= (rtDraw.right - 600);
			rtDraw.right = 600;
		}
		if (rtDraw.top < 0)
		{
			rtSprite.top += (-rtDraw.top);
			rtDraw.top = 0;

		}
		if (rtDraw.bottom > 600)
		{
			rtSprite.bottom -= (rtDraw.bottom - 600);
			rtDraw.bottom = 600;
		}

		(*m_pddsBB)->Blt(&rtDraw, m_psurBoss[0 + (*itor)->nOpt]->GetDDrawSurface(), 
						 &rtSprite,
						 DDBLT_WAIT | DDBLT_KEYSRC, NULL);
	}

}




//-----------------------------------------------------------------------------
//   
//------------------------------------------------------------------------------
void CBoss::DrawEnege(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	// 
	BOSS_LIST::iterator itor;
	RECT rtDraw, rtSprite;

	for (itor = m_listBoss.begin(); itor != m_listBoss.end(); ++itor)
	{
		MakeCenterToRect(&m_osEnege.pSpr[0].ptSprCenterPos,
						 &m_osEnege.pSpr[0].rcSprPos,
						 &(*itor)->ptEnege,
						 &rtDraw);

		rtSprite.left	= m_osEnege.pSpr[0].rcSprPos.left;
		rtSprite.top	= m_osEnege.pSpr[0].rcSprPos.top;
		rtSprite.right	= m_osEnege.pSpr[0].rcSprPos.right;
		rtSprite.bottom = m_osEnege.pSpr[0].rcSprPos.bottom;
		
		if ((*itor)->nOpt == 0)
		{
			int div;
			if (m_nStage != 2)
				div = 5;
			else
				div = 8;

			rtDraw.right   -= (400 - ((*itor)->nLife / div));
			rtSprite.right -= (400 - ((*itor)->nLife / div));
		}
		else if  ((*itor)->nOpt == 1)
		{
			rtDraw.right   -= (400 - ((*itor)->nLife / 3));
			rtSprite.right -= (400 - ((*itor)->nLife / 3));
		}
		else
		{
			rtDraw.right   -= (400 - ((*itor)->nLife / 3));
			rtSprite.right -= (400 - ((*itor)->nLife / 3));
		}

		//(*m_pddsBB)->Blt(&rtDraw, m_psurEnege->GetDDrawSurface(), 
		//				 &rtSprite,
		//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);


		(*m_pddsBB)->BltFast(rtDraw.left, rtDraw.top,
								m_psurEnege->GetDDrawSurface(), 
								&rtSprite,
								DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY );
	}


}



//-----------------------------------------------------------------------------
//  ۾
//-----------------------------------------------------------------------------
void CBoss::Destroy()
{
	// 
	BOSS_LIST::iterator itorBoss;
	for (itorBoss = m_listBoss.begin(); itorBoss != m_listBoss.end(); ++itorBoss)
	{
		delete (*itorBoss);
	}

	if (m_psurBoss[0]) m_psurBoss[0]->Destroy();
	if (m_psurBoss[1]) m_psurBoss[1]->Destroy();
	if (m_psurBoss[2]) m_psurBoss[2]->Destroy();
	if (m_psurEnege) m_psurEnege->Destroy();
	
	DestroyLOSD(&m_osBoss[0]);
	DestroyLOSD(&m_osBoss[1]);
	DestroyLOSD(&m_osBoss[2]);
	DestroyLOSD(&m_osEnege);
	
}




//-----------------------------------------------------------------------------
// Ʈ  ε
//-----------------------------------------------------------------------------
BOOL CBoss::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
		return FALSE;

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
	{		
		delete[] os->pSpr;
		os->pSpr = NULL;
		return FALSE;
	}

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  
//-----------------------------------------------------------------------------
void CBoss::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
		delete[] os->pSpr;	
	os->pSpr = NULL;
}



//-----------------------------------------------------------------------------
// ǥ ̿ؼ ȭ ǥ 
//-----------------------------------------------------------------------------
inline void CBoss::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
							POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);

}

















