//-----------------------------------------------------------------------------
// NOTE : CBullet Ŭ  
//  :   Ŭ
// ϸ : CBullet.cpp
// 2004.8.27	ora_llundiov
//-----------------------------------------------------------------------------


#include "CBullet.h"
#include <cmath>

//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CBullet::CBullet()
{
	m_psurBullet	= NULL;
}


CBullet::~CBullet()
 {

 }


//-----------------------------------------------------------------------------
 // ʱȭ Լ
//-----------------------------------------------------------------------------
void CBullet::Create(LPDIRECTDRAW7 *pDD, CForces *pForces)
{
	m_pDD = *pDD;
	m_pForces = pForces;
}





//-----------------------------------------------------------------------------
 // ʱⰪ..
//-----------------------------------------------------------------------------
void CBullet::InitBullet()
{
	AllDelBullet();
	
}




//-----------------------------------------------------------------------------
 // ʱⰪ..
//-----------------------------------------------------------------------------
void CBullet::LoadBullet()
{
	//  ۾
	ReleaseBullet();

	// Ʈ  б ## ϰ  ٶ ##
	LoadOnlySprData("spr\\enemy_bullet.spr", (ONLY_SPRITE*)&m_osBullet);

	// Ʈ ǥ б
	CreateSurfaceFromBitmap(&m_psurBullet, "image\\enemy_bullet.ora", NULL, NULL);
	m_psurBullet->SetColorKey(RGB(0, 0, 0));
}





//-----------------------------------------------------------------------------
// ʱⰪ..
//-----------------------------------------------------------------------------
void CBullet::ReleaseBullet()
{
	if (m_psurBullet) m_psurBullet->Destroy();
	DestroyLOSD(&m_osBullet);

	m_psurBullet = NULL;
}




//-----------------------------------------------------------------------------
// Ѿ ߰
//-----------------------------------------------------------------------------
void CBullet::AddBullet(int x, int y, int move, int kind)
{
	_BULLET *add;
	add = new _BULLET;
	if (add == NULL)
		return;

	add->nIndex = kind;
	add->nKind  = move;

	switch (move)
	{
	case 0:
		add->nCnt		= 2;
		add->pptBullet	= new POINT[add->nCnt];
		add->pbLife		= new BOOL[add->nCnt];
		add->pptBullet[0].x = x;
		add->pptBullet[0].y = y + 10;
		add->pptBullet[1].x = x;
		add->pptBullet[1].y = y + 10;
		add->pbLife[0]	= TRUE;
		add->pbLife[1]	= TRUE;
		break;

	case 1:
		add->nCnt		= 2;
		add->pptBullet	= new POINT[add->nCnt];
		add->pbLife		= new BOOL[add->nCnt];
		add->pptBullet[0].x = x - 30;
		add->pptBullet[0].y = y + 20;
		add->pptBullet[1].x = x + 30;
		add->pptBullet[1].y = y + 20;
		add->pbLife[0]	= TRUE;
		add->pbLife[1]	= TRUE;
		break;

	case 2:
		add->nCnt		= 5;
		add->pptBullet	= new POINT[add->nCnt];
		add->pbLife		= new BOOL[add->nCnt];

		add->pptBullet[0].x = x;
		add->pptBullet[0].y = y + 20;
		add->pptBullet[1].x = x;
		add->pptBullet[1].y = y + 20;
		add->pptBullet[2].x = x;
		add->pptBullet[2].y = y + 20;
		add->pptBullet[3].x = x;
		add->pptBullet[3].y = y + 20;
		add->pptBullet[4].x = x;
		add->pptBullet[4].y = y + 20;

		add->pbLife[0]	= TRUE;
		add->pbLife[1]	= TRUE;
		add->pbLife[2]	= TRUE;
		add->pbLife[3]	= TRUE;
		add->pbLife[4]	= TRUE;
		break;

	case 3:
		add->nCnt		= 5;
		add->pptBullet	= new POINT[add->nCnt];
		add->pbLife		= new BOOL[add->nCnt];

		add->pptBullet[0].x = x - 140;
		add->pptBullet[0].y = y + 20;
		add->pptBullet[1].x = x - 70;
		add->pptBullet[1].y = y + 20;
		add->pptBullet[2].x = x;
		add->pptBullet[2].y = y + 20;
		add->pptBullet[3].x = x + 70;
		add->pptBullet[3].y = y + 20;
		add->pptBullet[4].x = x + 140;
		add->pptBullet[4].y = y + 20;

		add->pbLife[0]	= TRUE;
		add->pbLife[1]	= TRUE;
		add->pbLife[2]	= TRUE;
		add->pbLife[3]	= TRUE;
		add->pbLife[4]	= TRUE;
		break;

	case 4:
		add->nCnt		= 3;
		add->pptBullet	= new POINT[add->nCnt];
		add->pbLife		= new BOOL[add->nCnt];
		add->pptBullet[0].x = x - 50;
		add->pptBullet[0].y = y + 10;
		add->pptBullet[1].x = x;
		add->pptBullet[1].y = y + 10;
		add->pptBullet[2].x = x + 50;
		add->pptBullet[2].y = y + 10;
		add->pbLife[0]	= TRUE;
		add->pbLife[1]	= TRUE;
		add->pbLife[2]	= TRUE;
		break;

	case 5:
		add->nCnt		= 1;
		add->pptBullet	= new POINT[add->nCnt];
		add->pbLife		= new BOOL[add->nCnt];
		add->pptBullet[0].x = x;
		add->pptBullet[0].y = y;
		add->pbLife[0] = TRUE;

		POINT pt = m_pForces->GetCenterPos();
		add->fMovex = pt.x - x;
		add->fMovey = pt.y - y;
		float length = sqrt(add->fMovex*add->fMovex + add->fMovey*add->fMovey);
		add->fMovex /= length;
		add->fMovey /= length;
		add->fMovex *= 8;
		add->fMovey *= 8;
		break;

	}

	m_listBullet.push_back(add);
}




//-----------------------------------------------------------------------------
// Ѿ  Ʈ
//-----------------------------------------------------------------------------
void CBullet::UpdateBullet()
{

	BULLET_LIST::iterator itor;
	BULLET_LIST::iterator del[30];
	int index = -1;

	for (itor = m_listBullet.begin(); itor != m_listBullet.end(); ++itor)
	{
		
		switch ((*itor)->nKind)
		{
		case 0: // Ѿ 1 ---------------------------------------------
			(*itor)->pptBullet[0].x++;
			(*itor)->pptBullet[0].y += 5;
			(*itor)->pptBullet[1].x--;
			(*itor)->pptBullet[1].y += 5;
			break;

		case 1: // Ѿ 2 ---------------------------------------------
			(*itor)->pptBullet[0].y += 10;
			(*itor)->pptBullet[1].y += 10;
			break;

		case 2: // Ѿ 3 ---------------------------------------------
			{
				int nMoveX[5] = { -4, -2, 0, 4, 2};
				for (int i = 0; i < 5; i++)
				{
					(*itor)->pptBullet[i].x += nMoveX[i];
					(*itor)->pptBullet[i].y += 3;
				}
			}
			break;

		case 3: // Ѿ 4 ---------------------------------------------
			{
				for (int i = 0; i < 5; i++)
				{
					(*itor)->pptBullet[i].y += 10;
				}
			}
			break;

		case 4: // Ѿ 5 ---------------------------------------------
			(*itor)->pptBullet[0].x += 3;
			(*itor)->pptBullet[0].y += 5;
			(*itor)->pptBullet[1].y += 5;
			(*itor)->pptBullet[2].x -= 3;
			(*itor)->pptBullet[2].y += 5;
			break;

		case 5:
			(*itor)->pptBullet[0].x += (*itor)->fMovex;
			(*itor)->pptBullet[0].y += (*itor)->fMovey;
			break;

		}

		//  üũ
		switch ((*itor)->nKind)
		{
		case 0:	// Ѿ 1 ---------------------------------------------
			for (int i = 0; i < 2; ++i)
			{
				if (((*itor)->pptBullet[i].x < -10) || ((*itor)->pptBullet[i].x > 610) ||
					((*itor)->pptBullet[i].y > 610) || ((*itor)->pptBullet[i].y < -10))
				{
					(*itor)->pbLife[i] = FALSE;
				}
			}

			if (((*itor)->pbLife[0] == FALSE) && ((*itor)->pbLife[1] == FALSE))
					del[++index] = itor;
			break;

		case 1:// Ѿ 2 ---------------------------------------------
			for (int i = 0; i < 2; ++i)
			{
				if (((*itor)->pptBullet[i].x < -10) || ((*itor)->pptBullet[i].x > 610) ||
					((*itor)->pptBullet[i].y > 610) || ((*itor)->pptBullet[i].y < -10))
				{
					(*itor)->pbLife[i] = FALSE;
				}
			}

			if (((*itor)->pbLife[0] == FALSE) && ((*itor)->pbLife[1] == FALSE))
					del[++index] = itor;
			break;

		case 2:// Ѿ 3 ---------------------------------------------
			{
				int nDestroy = 0;
				for (int i = 0; i < 5; ++i)
				{
					if (((*itor)->pptBullet[i].x < -10) || ((*itor)->pptBullet[i].x > 610) ||
						((*itor)->pptBullet[i].y > 610) || ((*itor)->pptBullet[i].y < -10))
					{
						(*itor)->pbLife[i] = FALSE;
						nDestroy++;
					}
				}

				if (nDestroy == 5)
						del[++index] = itor;
			}
			break;

		case 3: // Ѿ 4 ---------------------------------------------
			{
				int nDestroy = 0;
				for (int i = 0; i < 5; ++i)
				{
					if (((*itor)->pptBullet[i].x < -10) || ((*itor)->pptBullet[i].x > 610) ||
						((*itor)->pptBullet[i].y > 610) || ((*itor)->pptBullet[i].y < -10))
					{
						(*itor)->pbLife[i] = FALSE;
						nDestroy++;
					}
				}

				if (nDestroy == 5)
						del[++index] = itor;
			}
			break;

		case 4: // Ѿ 5 ---------------------------------------------
			for (int i = 0; i < 3; ++i)
			{
				if (((*itor)->pptBullet[i].x < -10) || ((*itor)->pptBullet[i].x > 610) ||
					((*itor)->pptBullet[i].y > 610) || ((*itor)->pptBullet[i].y < -10))
				{
					(*itor)->pbLife[i] = FALSE;
				}
			}

			if (((*itor)->pbLife[0]==FALSE) && ((*itor)->pbLife[1]==FALSE) && ((*itor)->pbLife[2]==FALSE))
					del[++index] = itor;
			break;

		case 5: // Ѿ 6 ---------------------------------------------
			for (int i = 0; i < 1; ++i)
			{
				if (((*itor)->pptBullet[i].x < -10) || ((*itor)->pptBullet[i].x > 610) ||
					((*itor)->pptBullet[i].y > 610) || ((*itor)->pptBullet[i].y < -10))
				{
					(*itor)->pbLife[i] = FALSE;
				}
			}

			if ((*itor)->pbLife[0] == FALSE)
					del[++index] = itor;
			break;
		}

	}// for

	// 
	
	for (int i = 0; i <= index; i++)
	{
		delete[] (*del[i])->pptBullet;
		delete[] (*del[i])->pbLife;
		delete	  (*del[i]);
		m_listBullet.erase(del[i]);
	}
}





//-----------------------------------------------------------------------------
//  Լ 
//------------------------------------------------------------------------------
void CBullet::Draw(LPDIRECTDRAWSURFACE7 *m_pddsBB)
{
	// Ѿ
	//UpdateBullet();

	// Ѿ
	BULLET_LIST::iterator itor;
	RECT rtDraw, rtSprite;

	for (itor = m_listBullet.begin(); itor != m_listBullet.end(); ++itor)
	{
		for (int i = 0; i < (*itor)->nCnt; i++)
		{
			// ȭ ǥ 
			MakeCenterToRect(&m_osBullet.pSpr[(*itor)->nIndex].ptSprCenterPos,
							 &m_osBullet.pSpr[(*itor)->nIndex].rcSprPos,
							 &((*itor)->pptBullet[i]),
							 &rtDraw);


		//## ----------------------------------------
		rtSprite.left	= m_osBullet.pSpr[(*itor)->nIndex].rcSprPos.left;
		rtSprite.top	= m_osBullet.pSpr[(*itor)->nIndex].rcSprPos.top;
		rtSprite.right	= m_osBullet.pSpr[(*itor)->nIndex].rcSprPos.right;
		rtSprite.bottom = m_osBullet.pSpr[(*itor)->nIndex].rcSprPos.bottom;


		
		//  Ų 
		if (rtDraw.left < 0)
		{
			rtSprite.left += (-rtDraw.left);
			rtDraw.left = 0;
		}
		if (rtDraw.right > 600)
		{
			rtSprite.right -= (rtDraw.right - 600);
			rtDraw.right = 600;
		}
		if (rtDraw.top < 0)
		{
			rtSprite.top += (-rtDraw.top);
			rtDraw.top = 0;

		}
		if (rtDraw.bottom > 600)
		{
			rtSprite.bottom -= (rtDraw.bottom - 600);
			rtDraw.bottom = 600;
		}
	

			// ׸
			if ((*itor)->pbLife[i])
			{
				//(*m_pddsBB)->Blt(&rtDraw, m_psurBullet->GetDDrawSurface(), 
				//				 &rtSprite,
				//				 DDBLT_WAIT | DDBLT_KEYSRC, NULL);


				(*m_pddsBB)->BltFast(rtDraw.left, rtDraw.top,
										m_psurBullet->GetDDrawSurface(), 
										&rtSprite,
										DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
			}
		}
	}

}





//-----------------------------------------------------------------------------
//  Ѿ 
//-----------------------------------------------------------------------------
void CBullet::AllDelBullet()
{
	BULLET_LIST::iterator itor;

	for (itor = m_listBullet.begin(); itor != m_listBullet.end(); ++itor)
	{
		delete[] (*itor)->pptBullet;
		delete[] (*itor)->pbLife;
		delete	  (*itor);
	}

	m_listBullet.clear();
}


//-----------------------------------------------------------------------------
//  ۾
//-----------------------------------------------------------------------------
void CBullet::Destroy()
{

	BULLET_LIST::iterator itor;
	for (itor = m_listBullet.begin(); itor != m_listBullet.end(); ++itor)
	{
		delete[] (*itor)->pbLife;
		delete[] (*itor)->pptBullet;
		delete[] (*itor);
	}


	if (m_psurBullet) m_psurBullet->Destroy();
	DestroyLOSD(&m_osBullet);
}




//-----------------------------------------------------------------------------
// Ʈ  ε
//-----------------------------------------------------------------------------
BOOL CBullet::LoadOnlySprData(char *filename, ONLY_SPRITE *os)
{
	FILE  *fp;
	size_t result;
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	result = fread(&(os->sprInfo), sizeof(SPR_INFO), 1, fp);
	if (result == 0)
		return FALSE;

	// Ʈ Ʈ б
	os->pSpr = new SPR[os->sprInfo.nSprCount];
	if (os->pSpr == NULL)
	{
		delete[] os->pSpr;
	}

	result = fread(os->pSpr, sizeof(SPR) * os->sprInfo.nSprCount, 1, fp);
	if (result == 0)
	{
		delete[] os->pSpr;
		os->pSpr = NULL;
		return FALSE;
	}

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  
//-----------------------------------------------------------------------------
void CBullet::DestroyLOSD(ONLY_SPRITE *os)
{
	if (os->pSpr != NULL)
		delete[] os->pSpr;
	os->pSpr = NULL;

	if (m_psurBullet)
	{
		m_psurBullet->Destroy();
	}

}



//-----------------------------------------------------------------------------
// ǥ ̿ؼ ȭ ǥ 
//-----------------------------------------------------------------------------
inline void CBullet::MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,
									   POINT *ptScreen, RECT *rtScreen)
{
	int left = ptScreen->x - ((ptSprite->x));	
	int top  = ptScreen->y - ((ptSprite->y));
	int right  = left + (rtSprite->right - rtSprite->left);
	int bottom = top  + (rtSprite->bottom - rtSprite->top);

	SetRect(rtScreen, left, top, right, bottom);

}

















