
//---------------------------------------------------------------------------
// Note : CD2D Ŭ 
// ϸ : CD2D.h
// 2004.08.27 ora_llundiov  
//---------------------------------------------------------------------------

#ifndef _CD2D_H_
#define _CD2D_H_

#include "CDDApplication.h"
#include "CSprite.h"
#include "CDirectShow.h"
#include "CForces.h"
#include "CBoom.h"
#include "CEnemy.h"
#include "CBullet.h"
#include "CItem.h"
#include "CMap.h"
#include "CEffect.h"
#include "CScript.h"
#include "CBoss.h"

//  
enum GAMESTATE { INTRO = -1, TITLE, CSELECT, PLAYING, GAMEOVER, METHOD, EXITGAME, S_INTRO, ENDING, CREDITT, PLAYMENU, RANKING, SETNAME };

// ŸƲ Ʈ
enum TITLESELECT { START, CREDIT, EXIT };

// ɸ Ʈ
enum CHANUM { SP, PAI, ZT};

// 
enum SOUND_EFFECT { CHANGE, SELECTED, SHOT_N, SHOT_M, SHOT_B, BOOM_S, BOOM_M, BOOM_L, ITEM, BOSS,
					 ENDING1, ENDING2, ENDING3, ENDING4, ENDING5,
					 CLEAR, MPMAX, CRASH };

enum BGM {BGM_TITLE, BGM_CSELECT, BGM_METHOD, BGM_STAGE1, BGM_STAGE2, BGM_STAGE3, BGM_CREDIT, BGM_GOVER, BGM_ENDING };

// Ű 
enum KEYDOWN { LEFT, RIGHT, UP, DOWN };

enum ENEMY_MOVE { ENEMY_MOVE_0, ENEMY_MOVE_1, ENEMY_MOVE_2, ENEMY_MOVE_3 };
enum BULLET_KIND { BULLET_KIND_0, BULLET_KIND_1, BULLET_KIND_2, BULLET_KIND_3, BULLET_KIND_4 };
enum BULLET_MOVE { BULLET_MOVE_0, BULLET_MOVE_1, BULLET_MOVE_2, BULLET_MOVE_3, BULLET_MOVE_4}; 

//  
enum ITEM_KIND {ITEM_P, ITEM_B, ITEM_A, ITEM_PW, ITEM_500 };

class CD2D;

// ŷ ü
struct RANK
{
	char szName[MAX_PATH];
	DWORD  score;
};


//class CD2D
//---------------------------------------------------------------------------
class CD2D : public CDDApplication
{
	private:
		int m_nGameStates;		// ӻ
		int m_nTitleSelect;		// ŸƲ  (START, CREDIT, EXIT)
		int m_nChaSelect;		// ĳ  (SP, PAI, ZT)
		int m_nStage;			//  (1~3)

		// ŸƲ ȭ  
		CSurface	*m_psurTitleBack;		// ŸƲ ׶ ǥ
		CSurface	*m_psurTitleSmaile;		//  ׸ ǥ
		CSurface	*m_psurTitleSmaile1;	//  ׸ ǥ
		CSurface	*m_psurTitleWord;		//  ǥ
		CSurface	*m_psurTitleCow;		// COWBOYBEBOP THE ORANGE ǥ
		ONLY_SPRITE	 m_osTitleCow;			// COWBOYBEBOP THE ORANGE 
		ONLY_SPRITE  m_osTitleWord;			//  
		POINT		 m_ptSmailePos[3];		//   ǥ
		POINT		 m_ptWordPos[3];		// ý  

		DWORD		 m_dwStartDealy;		// ŸƮ    
		BOOL		 m_bStart;				// ŸƮ 

		// ŸƲ   
		BOOL		 m_bDrawCow[12];		
		BOOL		 m_bCowUpdate;
		int			 m_nCowIndex;
		DWORD		 m_dwCowDealy;
		POINT		 m_ptCowPos[12];
		BOOL		 m_bDrawOrange;

		

		// ĳ  ȭ 
		CSurface	*m_psurCSelectBack;	// 
		CSurface	*m_psurCSelectCha;	// ĳ ׸
		ONLY_SPRITE	 m_osCSelectCha;	// ĳ Ʈ 
		CSurface	*m_psurCSelectInfo;	// ĳ 
		ONLY_SPRITE	 m_osCSelectInfo;	// ĳ  Ʈ 
		CSurface	*m_psurCSelectShip; // ü 
		ONLY_SPRITE  m_osCSelectShip;	// ü  Ʈ 
		POINT		 m_ptCSelectPos[3];	// (0:ĳ 1:ĳ 2:ü) ߽ ǥ

		// ÷ ȭ 
		CSurface	*m_psurPlayInfo;	// ÷  ǥ
		RECT		 m_rtPlayInfo;		// ÷   ǥ

		// ӿ
		CSurface	*m_psurGameOver;	// ӿ ǥ

		//   ȭ
		CSurface	*m_psurMethod;		//   ȭ ǥ

		//   ȭ
		CSurface	*m_psurExitGame;
		ONLY_SPRITE	 m_osExitGame;
		POINT		 m_ptExitGame;

		//  Ұȭ
		DWORD		 m_dwTimeSIntro;
		CSurface	*m_psurSIntro;

		//  ȭ
		CSurface	*m_psurEnding;
		CSurface	*m_psurEndingBack;
		ONLY_SPRITE	 m_osEnding;
		POINT		 m_ptDraw[13];
		BOOL		 m_bEndDraw[13];
		DWORD		 m_dwEndDealy;
		int			 m_nEndIndex;

		//  ȭ
		CSurface	*m_psurCredit;
		CSurface	*m_psurCreditPic;
		ONLY_SPRITE	 m_osCredit;
		ONLY_SPRITE	 m_osCreditPic;
		POINT		 m_ptCrePos;
		POINT		 m_ptPicPos;
		DWORD		 m_dwCreDealy;
		DWORD		 m_dwPicDealy;
		int			 m_nPicIndex;
		BOOL		 m_bPlay;

		// ÷ ޴ ȭ
		CSurface	*m_psurPlayMenu;
		ONLY_SPRITE	 m_osPlayMenu;
		int			 m_nPlayMenu;

		// ӽú
		RECT m_rtDraw;
		RECT m_rtSprite;

		// Ŭ Ʈs
		CForces		m_cfForces;			// ɸ
		CBoom		m_Boom;				//  Ʈ
		CEnemy		m_Enemy;			// ü
		CBullet		m_Bullet;			//  Ѿ
		CItem		m_Item;				// 
		CMap		m_Map;				// 
		CEffect		m_Effect;			// Ÿ Ʈ
		CScript		m_Script;			// ũƮ
		CBoss		m_Boss;				// 

		// ŷ  
		RANK		 m_Rank[4];
		CSurface	*m_psurRankBack;
		DWORD		 m_dwRankDealy;


		// ŷ̸   
		CSurface	*m_psurSetName;
		char		 m_szName[MAX_PATH];
		int			 m_NameIndex;

		// DirectShow
		char m_strBGM[9][MAX_PATH];		//  ϰ
		CDirectShow m_DShow;			// ٿ SHOW - MP3 

		// ÷ȭ Űٿ ÷
		BOOL m_bKeydown[4];


	public:
		CD2D();
		virtual ~CD2D();

		// Լ
		virtual HRESULT FrameMove(); 				//   Ÿ Ʈ
		virtual HRESULT Render();	 				//  κ
		virtual HRESULT RestoreAllSurface(); 		// Ʈ ǥ 
		virtual void	 InitAllSurface();			// Ʈ  ʱȭ
		virtual void	 DeleteAllSurface(); 		// Ʈ ǥ 

		//  ʱȭ Լ(ε )
		void InitCBTO();

		//  
		void PrintFPS();

		//  Լ
		void CD2D::MyTextOut(char *lpszPrint, int xPos, int yPos, COLORREF clrText,
							 char *lpszFont = NULL, int nSize = 9);

		// ȭ  Լ
		void RenderIntro();		// Ʈ ȭ
		void RenderTitle();		// ŸƲ ȭ
		void RenderCSelect();	// ɸ Ʈ
		void RenderPlaying();	// ÷ ȭ
		void RenderGameOver();	//  
		void RenderMethod();	//  ÷̹
		void RenderExitGame();	//  
		void RenderStageIntro();//  Ʈ
		void RenderEnding();	// 
		void RenderCredit();	//  
		void RederPlayMenu();	// ÷ ޴
		void RenderRank();
		void RenderSetName();

		
		// Ű Է Լ
		void InputTitle();		// ŸƲ ȭ
		void InputCSelect();	// ɸ Ʈ
		void InputPlaying();	// ÷ ȭ
		void InputGameOver();	// ӿ
		void InputMethod();		//  ÷̹
		void InputCredit();		//  
		void InputPlayMenu();	// ÷ ޴
		void InputRank();
		void InputEnding();
		void InputSetName();

		// Ʈ ε Լ
		void LoadTitle();				// ŸƲ
		void LoadCSelect();				// ɸ Ʈ
		void LoadMethod();				//  
		void LoadSIntro(int nStage);	//  Ұ
		void LoadGameOver();			//  
		void LoadGameExit();			//  
		void LoadEnding();				// 
		void LoadCredit();				// 
		void LoadPlayMenu();			// ÷ ޴
		void LoadRank();
		void LoadSetName();

		// Ʈ   Լ
		void ReleaseTitle();			// ŸƲ
		void ReleaseCSelect();			// ɸ Ʈ
		void ReleaseMethod();			//  
		void ReleaseSIntro();			//  Ұ
		void ReleaseGameOver();			// ӿ
		void ReleaseGameExit();			//  
		void ReleaseEnding();			// 
		void ReleaseCredit();			// 
		void ReleasePlayMenu();			// ÷ ޴
		void ReleaseRank();
		void ReleaseSetName();

		// ŷ  Լ
		void RankLoad();
		void RankSave();

		// Ʈ ͸ ε ϴ Լ
		BOOL  LoadOnlySprData(char *filename, ONLY_SPRITE *os);
		void DestroyLOSD(ONLY_SPRITE *os);

		// 浹 ˻ 
		inline void MakeCenterToRect(POINT *ptSprite, RECT *rtSprite,	// ߽ǥ ̿ؼ  ǥ 
									   POINT *ptScreen, RECT *rtScreen); 

		// Ʈǥ 浹 ǥ -> ȭ鼺 ⵹ǥ ȯ
		inline void MakeCollToRect(POINT *ptSprite, RECT *rtSprite, RECT *rtColl,
									POINT *ptScreen, RECT *rtScreen);
		// ü ѵ˻ Լ
		void CheckCrash();
		int	  NewScore();

		// 浹 ˻ Լ
		BOOL IsCrash(RECT rt1, RECT rt2);

};
//---------------------------------------------------------------------------
#endif











