
//-----------------------------------------------------------------------------
// Note : CDDApplication Ŭ 
// ϸ : CDDApplication.cpp
// 2004.04.06 ora_llundiov 
//-----------------------------------------------------------------------------

#include <ddraw.h>
#include <mmsystem.h>

#include "CDDApplication.h"


//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CDDApplication::CDDApplication()
{
	m_dwFPS		= 0;
	m_dwDealy	= FPS;
	strcpy(m_strFrameStats, "0 fps");
}


CDDApplication::~CDDApplication()
{
	m_bReady = FALSE;
	DeleteAllSurface(); // Ʈ ǥ 
}



//-----------------------------------------------------------------------------
//  DDraw   
//-----------------------------------------------------------------------------
BOOL CDDApplication::InitDeviceObject(HWND hWnd)
{
	// DDRAW ʱȭ
	m_hWnd		= hWnd;
	m_bWindowed = TRUE;

	// Ŭ̾Ʈ ȭ ǥ 
	UpdateBounds();

	// Ŭ̾Ʈ ȭ ũ (width , height) 
	m_dwWidth  = m_rcWindow.right  - m_rcWindow.left + 1;
	m_dwHeight = m_rcWindow.bottom - m_rcWindow.top  + 1;

	// Direct Draw 
	if (FAILED(CreateWindowedDisplay(hWnd, m_dwWidth, m_dwHeight)))
		return FALSE;

	// Surface ʱȭ κ(Ʈ ε Ʈ ǥ )
	InitAllSurface();

	// ̷Ʈ ǲ ʱȭ
	if (FAILED(m_DInputKey.InitDirectInput(hWnd, FALSE, FALSE, TRUE)))
		return FALSE;

	// DDraw  
	m_bReady = TRUE;

	return TRUE;
}



//-----------------------------------------------------------------------------
//  DDraw Ǯũ   :: (ڵ,,,Ʈ)
//-----------------------------------------------------------------------------
BOOL CDDApplication::InitDeviceObject(HWND hWnd,
									  DWORD dwWidth, DWORD dwHeight, 
									  DWORD dwBpp)
{
	m_hWnd		= hWnd;
	m_dwWidth	= dwWidth;
	m_dwHeight	= dwHeight;
	m_dwBpp		= dwBpp;

	if (FAILED(CreateFullScreenDisplay(hWnd, dwWidth, dwHeight, dwBpp)))
		return FALSE;

	// Ŭ 
	//if (FAILED(InitClipper()))
	//	return FALSE;

	// Surface ʱȭ κ(Ʈ ε Ʈ ǥ )
	InitAllSurface();

	// ̷Ʈ ǲ ʱȭ
	if (FAILED(m_DInputKey.InitDirectInput(hWnd, FALSE, FALSE, TRUE)))
		return FALSE;

	// DDraw  
	m_bReady = TRUE;

	return TRUE;
}



//-----------------------------------------------------------------------------
// 2D  Լ :: ȭ鿡  ü ׸.
//-----------------------------------------------------------------------------
HRESULT CDDApplication::Render2DEnvironment()
{
	HRESULT hr;

	DWORD dwCur = timeGetTime();
	static DWORD dwStart = dwCur;


	// Ÿ 
	FrameMove();


	// ȭ Device Ҿ ó κ
	if (FAILED(hr = GetDirectDraw()->TestCooperativeLevel()))
	{
		switch (hr)
		{
		case DDERR_EXCLUSIVEMODEALREADYSET:
			Sleep(10);
			return S_OK;

		case DDERR_WRONGMODE:
			//  Surface  ٽ DDraw 
			DeleteAllSurface();
			if (IsWindowed())
				InitDeviceObject(m_hWnd);
			else
				InitDeviceObject (m_hWnd, m_dwWidth, m_dwHeight, m_dwBpp);
			InitAllSurface();
			return S_OK;
		}

		return hr;
	}


	//  ϴ κ
	// Clear(0); // ȭ 

	Render(); // ȭ  Լ ()


	// FPS κ :: PFS Ӽ
	while((timeGetTime() - dwCur) < m_dwDealy);

	m_dwFPS++;

	if (timeGetTime() - dwStart > 1000) 
	{
		if (m_dwFPS >= 35)
			m_dwDealy += 3;
		else if (m_dwFPS <= 29)
			m_dwDealy -= 3;

		wsprintf(m_strFrameStats, "%ld fps", m_dwFPS);
		m_dwFPS = 0;
		dwStart = GetTickCount();
	}
	

	//  ø κ
	if (FAILED(hr = Present()))
	{
		if (hr != DDERR_SURFACELOST)
			return hr;

		m_pDD->RestoreAllSurfaces();
		RestoreAllSurface(); // Sprite Surface
		return S_OK;
	}

	return S_OK;
}



//-----------------------------------------------------------------------------
// DDraw  Ǿ  üũ
//-----------------------------------------------------------------------------
BOOL CDDApplication::IsReady()
{
	return m_bReady;
}



//-----------------------------------------------------------------------------
//  ڵ  Լ
//-----------------------------------------------------------------------------
void CDDApplication::SetHWnd(HWND hWnd)
{
	m_hWnd = hWnd;
}



//-----------------------------------------------------------------------------
//    ۸ ٽ ִ κ
//-----------------------------------------------------------------------------
HRESULT CDDApplication::Resize2DEnvironment()
{
	HRESULT hr;
	UpdateBounds();

	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);

	ddsd.dwFlags		= DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
	ddsd.ddsCaps.dwCaps	= DDSCAPS_OFFSCREENPLAIN | DDSCAPS_3DDEVICE;
	ddsd.dwWidth		= m_rcWindow.right - m_rcWindow.left;
	ddsd.dwHeight		= m_rcWindow.bottom - m_rcWindow.top;

	if (FAILED(hr = m_pDD->CreateSurface(&ddsd, &m_pddsBackBuffer, NULL)))
		return E_FAIL;

	return S_OK;
}






