
//-----------------------------------------------------------------------------
// Note: CDirectShow Ŭ  
// ϸ: CDirectShow.cpp
// : CBTO MP3÷̸  Ŭ
// 2004.6.4 ora_llundiov
//-----------------------------------------------------------------------------

#include "CDirectShow.h"



//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CDirectShow::CDirectShow()
{
	m_pGraphBuilder = NULL;
	m_pMediaControl = NULL;
	m_pMediaSeeking = NULL;

	m_nCountFilter = 0;
	m_bReady = FALSE;

}


CDirectShow::~CDirectShow()
{
	Destory();
}



//-----------------------------------------------------------------------------
// DIRECTX SHOW ʱȭ Լ
//-----------------------------------------------------------------------------
HRESULT	CDirectShow::InitDirectShow()
{
	HRESULT hr = S_OK;

	//  ʱȭ
	//if(FAILED(hr = CoInitialize(NULL)))
	//	return hr;

    // ׷ 
    if(FAILED(hr = CoCreateInstance(CLSID_FilterGraph, NULL,
        CLSCTX_INPROC, IID_IGraphBuilder,
        reinterpret_cast<void **>(&m_pGraphBuilder))))  
        return hr;

    // ̵Ʈ ̽ 
    if(FAILED(hr = m_pGraphBuilder->QueryInterface(IID_IMediaControl,
        reinterpret_cast<void **>(&m_pMediaControl))))
        return hr;

    // ̵ ŷ ̽ 
    if(FAILED(hr = m_pGraphBuilder->QueryInterface(IID_IMediaSeeking,
        reinterpret_cast<void **>(&m_pMediaSeeking))))
        return hr;

	return S_OK;
}




//-----------------------------------------------------------------------------
// Լ index(0 - BASE!!)
//-----------------------------------------------------------------------------
HRESULT	CDirectShow::Play(char *filename)
{
	HRESULT hr = S_OK;
	WCHAR wstrFilename[MAX_PATH];
	IPin *pPin = NULL;

	// ASCII -> UNICODE
	MultiByteToWideChar(CP_ACP, 0, filename, -1, wstrFilename, MAX_PATH);

	
	//  ߰
	hr = m_pGraphBuilder->AddSourceFilter(wstrFilename, wstrFilename, &m_pBaseFilter);


	//PIBaseFilter temp = (PIBaseFilter)(pos);
	if(SUCCEEDED(hr))
    {
		hr = m_pBaseFilter->FindPin(L"Output", &pPin);  
    }

	// Stop the graph
    if(SUCCEEDED(hr))
    {
        hr = m_pMediaControl->Stop();
    }
//--------------------------------------------
	//   
	if(SUCCEEDED(hr))
    {
        IEnumFilters *pFilterEnum = NULL;

        if(SUCCEEDED(hr = m_pGraphBuilder->EnumFilters(&pFilterEnum)))
        {
            int iFiltCount = 0;
            int iPos = 0;

            // Need to know how many filters. If we add/remove filters during the
            // enumeration we'll invalidate the enumerator
            while(S_OK == pFilterEnum->Skip(1))
            {
                iFiltCount++;
            }

            // Allocate space, then pull out all of the 
            IBaseFilter **ppFilters = reinterpret_cast<IBaseFilter **>
                                      (_alloca(sizeof(IBaseFilter *) * iFiltCount));
            pFilterEnum->Reset();

            while(S_OK == pFilterEnum->Next(1, &(ppFilters[iPos++]), NULL));

            SAFE_RELEASE(pFilterEnum);

            for(iPos = 0; iPos < iFiltCount; iPos++)
            {
                m_pGraphBuilder->RemoveFilter(ppFilters[iPos]);

				if(ppFilters[iPos] != m_pSourceCurrent)
                {
                    m_pGraphBuilder->AddFilter(ppFilters[iPos], NULL);
                }
                SAFE_RELEASE(ppFilters[iPos]);
            }
        }
    }

	if(SUCCEEDED(hr))
    {
        // Release the old source filter, if it exists
        SAFE_RELEASE(m_pSourceCurrent)

        hr = m_pGraphBuilder->Render(pPin);
        m_pSourceCurrent = m_pBaseFilter;
        m_pBaseFilter = NULL;
    }

	SAFE_RELEASE(pPin);
	SAFE_RELEASE(m_pBaseFilter);


	// ó  
    if(SUCCEEDED(hr))
    {
        LONGLONG llPos = 0;
        hr = m_pMediaSeeking->SetPositions(&llPos, AM_SEEKING_AbsolutePositioning,
                                           &llPos, AM_SEEKING_NoPositioning);
    } 

	// Start the graph
    if(SUCCEEDED(hr))
    {
        hr = m_pMediaControl->Run();
    }


	return S_OK;
}




//-----------------------------------------------------------------------------
//  Լ
//-----------------------------------------------------------------------------
HRESULT CDirectShow::Stop()
{
	if(m_pMediaControl)
		m_pMediaControl->Stop();

	return S_OK;
}



//-----------------------------------------------------------------------------
//  Լ
//-----------------------------------------------------------------------------
void CDirectShow::Destory()
{
	HRESULT hr = S_OK;

    if(m_pMediaControl)
        m_pMediaControl->Stop();

    // Release all remaining pointers
    SAFE_RELEASE(m_pBaseFilter);
    SAFE_RELEASE(m_pSourceCurrent);
    SAFE_RELEASE(m_pMediaSeeking);
    SAFE_RELEASE(m_pMediaControl);
    SAFE_RELEASE(m_pGraphBuilder);

    // Clean up COM
   // CoUninitialize();
}

















