//-----------------------------------------------------------------------------
// Note : DirectMusic CDxMusic Ŭ 
//  : CDxMusic.cpp
//-----------------------------------------------------------------------------

#include "CDxMusic.h"



//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CDxMusic::CDxMusic()
{
	m_pPerformance	= NULL;
	m_pLoader		= NULL;
	m_pAudioPath	= NULL;
}


CDxMusic::~CDxMusic()
{
	Release();
}


//-----------------------------------------------------------------------------
// ̷Ʈ  ʱȭ
// COM ʱȭ  ս δ 
//-----------------------------------------------------------------------------
BOOL CDxMusic::Init()
{
	HRESULT hr;

	// COM ʱȭ
	if (FAILED(hr = CoInitialize(NULL)))
		return FALSE;

	// δ 
	if (FAILED(hr = CoCreateInstance(CLSID_DirectMusicLoader, NULL, CLSCTX_INPROC,
		IID_IDirectMusicLoader8, (void**)&m_pLoader)))
		return FALSE;

	// ս 
	if (FAILED(hr = CoCreateInstance(CLSID_DirectMusicPerformance, NULL, CLSCTX_INPROC,
		IID_IDirectMusicPerformance8, (void**)&m_pPerformance)))
		return FALSE;

	return TRUE;
}


//-----------------------------------------------------------------------------
// ս 
//-----------------------------------------------------------------------------
BOOL CDxMusic::SetPerformance()
{
	HRESULT hr;

	if (FAILED(hr = m_pPerformance->InitAudio(NULL, NULL, NULL, DMUS_APATH_DYNAMIC_STEREO,
		64, DMUS_AUDIOF_ALL, NULL)))
		return FALSE;

	if (FAILED(hr = m_pPerformance->GetDefaultAudioPath(&m_pAudioPath)))
		return FALSE;
	
	return TRUE;
}


//-----------------------------------------------------------------------------
// ׸Ʈ Ÿ ε
//-----------------------------------------------------------------------------
BOOL CDxMusic::DataLoad(char *filename)
{
	HRESULT hr;
	WCHAR wstrFileName[MAX_PATH];
	CHAR strFileName[MAX_PATH];
	strcpy(strFileName,filename);

	// ASCII -> UNICODE
	MultiByteToWideChar(CP_ACP, 0, strFileName, -1, wstrFileName, MAX_PATH);

	// ο Ʈ ߰
	LPDM_SEGMENT insert;
	insert = new DM_SEGMENT;
	if (insert == NULL)
		return FALSE;
	insert->pSegment = NULL;

	//  ߰
	m_listSegments.push_back(insert);
	
	// Ÿ ε
	if (FAILED(hr = m_pLoader->LoadObjectFromFile(CLSID_DirectMusicSegment,
		IID_IDirectMusicSegment8, wstrFileName, (LPVOID*)&insert->pSegment)))
		return FALSE;

	return TRUE;
}


//-----------------------------------------------------------------------------
// ׸Ʈ   (׸Ʈ ε 0 BASE!!!!)
//-----------------------------------------------------------------------------
BOOL CDxMusic::PlaySound(UINT index,BOOL bLoop)
{
	DWORD dwFlag;
	HRESULT hr;

	//  ó
	if (m_listSegments.size() <= index)
		return FALSE;

	//  index ˻
	LIST::iterator pos = m_listSegments.begin();
	for (UINT i = 0; i < index; i++)
	{
		++pos;
	}

	(*pos)->pSegment->Download(m_pAudioPath);

	//  
	if (bLoop)
	{
		(*pos)->pSegment->SetRepeats(DMUS_SEGF_DEFAULT);
		dwFlag = DMUS_SEGF_DEFAULT;
	}
	else
	{
		dwFlag = DMUS_SEGF_DEFAULT | DMUS_SEGF_SECONDARY;
	}

	//  
	if (FAILED(hr = m_pPerformance->PlaySegmentEx((*pos)->pSegment, NULL, NULL,
		dwFlag, 0, NULL, NULL, NULL)))
		return FALSE;

	return TRUE;
}


//-----------------------------------------------------------------------------
// ׸Ʈ  
//-----------------------------------------------------------------------------
BOOL CDxMusic::StopSound(UINT index)
{
	HRESULT hr;

	//  ó
	if (m_listSegments.size() <= index)
		return FALSE;

	//  index ˻
	LIST::iterator pos = m_listSegments.begin();
	for (UINT i = 0; i < index; i++)
	{
		++pos;
	}

	//  
	if (FAILED(hr = m_pPerformance->Stop((*pos)->pSegment, NULL, 0, 0)))
		return FALSE;

	return TRUE;
}



//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
VOID CDxMusic::Release()
{
	//  
	SAFE_RELEASE(m_pLoader);
	
	if (m_pPerformance)
	{
		m_pPerformance->Stop(NULL, NULL, 0, 0);
		m_pPerformance->CloseDown();
		SAFE_RELEASE(m_pPerformance);
	}

	// COM 
	CoUninitialize();

	// DM_SEGMENT Ҵ 
	LIST::iterator pos;
	for (pos = m_listSegments.begin(); pos != m_listSegments.end(); ++pos)
	{
		delete (*pos);
	}
}

















