//-----------------------------------------------------------------------------
// NOTE : CKeyBoard Ŭ 
// ϸ : CKeyBoard.cpp
// 2004.4.28 ora_llundiov  
//-----------------------------------------------------------------------------

#include "CKeyboard.h"


//-----------------------------------------------------------------------------
//  / Ҹ
//-----------------------------------------------------------------------------
CKeyboard::CKeyboard()
{
	m_bReady	= FALSE;
	m_pDI		= NULL;
	m_pKeyboard	= NULL;
}

CKeyboard::~CKeyboard()
{
	ReleaseDirectInput();
}



//-----------------------------------------------------------------------------
// ̷Ʈ ǲ ʱȭ
//-----------------------------------------------------------------------------
HRESULT CKeyboard::InitDirectInput(HWND hWnd,BOOL bImmediate,BOOL bExclusive,
								   BOOL bForeground)
{
	DWORD   dwCoopFlags;
	HRESULT hr;

	// ¼ ÷
	if (bExclusive)
        dwCoopFlags = DISCL_EXCLUSIVE;
    else
        dwCoopFlags = DISCL_NONEXCLUSIVE;

    if (bForeground)
        dwCoopFlags |= DISCL_FOREGROUND;
    else
        dwCoopFlags |= DISCL_BACKGROUND;

	// ̷Ʈ ǲ ü 
	if (FAILED(hr = DirectInput8Create(GetModuleHandle(NULL), DIRECTINPUT_VERSION, 
                                         IID_IDirectInput8, (VOID**)&m_pDI, NULL)))
        return hr;

	 // ǲ ̽ 
	 if (FAILED(hr = m_pDI->CreateDevice(GUID_SysKeyboard, &m_pKeyboard, NULL)))
        return hr;

	 //   
	 if(FAILED(hr = m_pKeyboard->SetDataFormat(&c_dfDIKeyboard)))
        return hr;

	 //   
	 hr = m_pKeyboard->SetCooperativeLevel(hWnd, dwCoopFlags);
	 if(hr = DIERR_UNSUPPORTED && !bForeground && bExclusive)
	 {
        ReleaseDirectInput();
        return S_OK;
	 }

    if(FAILED(hr))
        return hr;

	//  뿩
	if(!bImmediate)
    {
        DIPROPDWORD dipdw;

        dipdw.diph.dwSize       = sizeof(DIPROPDWORD);
        dipdw.diph.dwHeaderSize = sizeof(DIPROPHEADER);
        dipdw.diph.dwObj        = 0;
        dipdw.diph.dwHow        = DIPH_DEVICE;
        dipdw.dwData            = BUFFER_SIZE_KEY; // Arbitary buffer size

        if(FAILED(hr = m_pKeyboard->SetProperty(DIPROP_BUFFERSIZE, &dipdw.diph)))
            return hr;
    }

	//  ȹ
	m_pKeyboard->Acquire();

	m_bImmediate = bImmediate;

	return S_OK;
}



//-----------------------------------------------------------------------------
//  б
//-----------------------------------------------------------------------------
HRESULT CKeyboard::ReadImmediateData(LPBYTE keyState)
{
	HRESULT hr;

	if(m_pKeyboard == NULL || m_bImmediate == FALSE) 
        return S_OK;

	//  б
    ZeroMemory(keyState, sizeof(keyState));
    hr = m_pKeyboard->GetDeviceState(sizeof(*keyState) * 256, keyState);

    if(FAILED(hr)) // 
    {
        hr = m_pKeyboard->Acquire();

        while(hr == DIERR_INPUTLOST) 
            hr = m_pKeyboard->Acquire();

        return S_OK; 
    }

	return S_OK;
}



//-----------------------------------------------------------------------------
// ۸ ̿  б
//-----------------------------------------------------------------------------
HRESULT CKeyboard::ReadBufferedData(LPDIDEVICEOBJECTDATA didod,LPDWORD dwElements)
{
	HRESULT hr;

	if (m_pKeyboard == NULL || m_bImmediate == TRUE) 
        return S_OK;

	// Ÿ б
	*dwElements = BUFFER_SIZE_KEY;
    hr = m_pKeyboard->GetDeviceData(sizeof(DIDEVICEOBJECTDATA),
                                     didod, dwElements, 0);
    if (hr != DI_OK) 
    {
        hr = m_pKeyboard->Acquire();

        while(hr == DIERR_INPUTLOST) 
            hr = m_pKeyboard->Acquire();

        return S_OK; 
    }

	return S_OK;
}



//-----------------------------------------------------------------------------
// ̷Ʈ ǲ 
//-----------------------------------------------------------------------------
void CKeyboard::ReleaseDirectInput()
{
    if(m_pKeyboard) 
        m_pKeyboard->Unacquire();
    
    SAFE_RELEASE(m_pKeyboard);
    SAFE_RELEASE(m_pDI);
}







