//-----------------------------------------------------------------------------
// Note : CSprite Class  
// ϸ : CSprite.cpp
// 2004.3.18 T?_llundiov
//-----------------------------------------------------------------------------


#include "CSprite.h"
#include <stdio.h>


//-----------------------------------------------------------------------------
// CSprite Ŭ  / Ҹ
//-----------------------------------------------------------------------------

//  
CSprite::CSprite() 
{
	bReady	 = FALSE;
	m_pAni	 = NULL;
	m_pSpr	 = NULL;
	m_pSound = NULL;

	memset(&m_sprInfo, 0, sizeof(SPR_INFO));
}


//  Ҹ
CSprite::~CSprite() 
{
	if (bReady == TRUE)
		Destroy();
}



//-----------------------------------------------------------------------------
// ʱȭ ۾ (Ҵ & ⺻ )
//-----------------------------------------------------------------------------
BOOL CSprite::Init()
{
	// Ʈ
	m_pSpr = new SPR;
	if (m_pSpr == NULL) 
		return FALSE;
	m_pSpr->next = NULL;

	// ִϸ̼
	m_pAni = new ANI;
	if (m_pAni == NULL)
	{
		delete m_pSpr;
		return FALSE;
	}
	m_pAni->next = NULL;


	// 
	m_pSound = new SOUND;
	if (m_pSound == NULL)
	{
		delete m_pSpr;
		delete m_pAni;
		return FALSE;
	}
	m_pSound->next = NULL;
	

	bReady = TRUE;

	return TRUE;
}



//-----------------------------------------------------------------------------
//  ۾ (Ҵ )
//-----------------------------------------------------------------------------
void CSprite::Destroy()
{
	if (bReady == FALSE)
		return;

	SPR *sprHead = m_pSpr;
	SPR *sprDel;

	ANI *aniHead = m_pAni;
	ANI *aniDel;

	SOUND *sndHead = m_pSound;
	SOUND *sndDel;


	// Ʈ   
	while (sprHead->next != NULL)
	{
		sprDel  = sprHead;
		sprHead = sprHead->next;
		delete sprDel;
	}
	delete sprHead;

	// ִϸ̼   
	while (aniHead->next != NULL)
	{
		aniDel  = aniHead;
		aniHead = aniHead->next;
		delete aniDel;
	}
	delete aniHead;

	//    
	while (sndHead->next != NULL)
	{
		sndDel  = sndHead;
		sndHead = sndHead->next;
		delete sndDel;
	}
	delete sndHead;

	bReady = FALSE;
	
	memset(&m_sprInfo, 0, sizeof(SPR_INFO));

}




//-----------------------------------------------------------------------------
// Ʈ ߰
//-----------------------------------------------------------------------------
BOOL CSprite::SprAdd(RECT *rtPos, RECT *rtCol, POINT *ptCenter, DWORD dwTime)
{
	SPR *last = m_pSpr;
	SPR *add  = NULL;

	// ο  
	add = new SPR;
	if (add == NULL)
		return FALSE;

	// ο 忡  
	memcpy(&(add->rcSprPos), rtPos, sizeof(RECT));

	if (rtCol != NULL)
		memcpy(&(add->rcSprCollision), rtCol, sizeof(RECT));
	else
		memset(&(add->rcSprCollision), 0, sizeof(RECT));

	if (ptCenter != NULL)
		memcpy(&(add->ptSprCenterPos), ptCenter, sizeof(POINT));
	else
		memset(&(add->ptSprCenterPos), 0, sizeof(RECT));

	add->dwTime = dwTime;
	add->next = NULL;


	// ߰Ұ Search.. ..
	while (last->next != NULL)
		last = last->next;

	// ߰
	last->next = add;

	// Ʈ īƮ 
	m_sprInfo.nSprCount++;

	return TRUE;
}




//-----------------------------------------------------------------------------
// Ʈ ߰ - ε ̿
//-----------------------------------------------------------------------------
BOOL CSprite::SprAdd(SPR *spr)
{
	SPR *last = m_pSpr;
	SPR *add  = NULL;

	// ο  
	add = new SPR;
	if (add == NULL)
		return FALSE;

	// ο 忡  
	memcpy(add, spr, sizeof(SPR));
	add->next = NULL;


	// ߰Ұ Search.. ..
	while (last->next != NULL)
		last = last->next;

	// ߰
	last->next = add;

	return TRUE;
}




//-----------------------------------------------------------------------------
// Ʈ - 浹 
//-----------------------------------------------------------------------------
BOOL CSprite::SprSetCol(int nIndex, RECT *rtCol)
{
	SPR *set = m_pSpr->next; // 0κ̽ 1̽ 򰥷  2004.5.11
	int i;

	if (nIndex >= m_sprInfo.nSprCount)
		return FALSE;

	//  ε 带 ã´.
	for (i = 0; i < nIndex; i++)
	{
		set = set->next;
	}

	// 
	memcpy(&(set->rcSprCollision), rtCol, sizeof(RECT));

	return TRUE;

}



//-----------------------------------------------------------------------------
// Ʈ - ߽ǥ 
//-----------------------------------------------------------------------------
BOOL CSprite::SprSetCenter(int nIndex, POINT* ptCenter)
{
	SPR *set = m_pSpr->next;
	int i;

	if (nIndex >= m_sprInfo.nSprCount)
		return FALSE;

	//  ε 带 ã´.
	for (i = 0; i < nIndex; i++)
	{
		set = set->next;
	}

	// 
	memcpy(&(set->ptSprCenterPos), ptCenter, sizeof(POINT));

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ - Ÿ̹ 
//-----------------------------------------------------------------------------
BOOL CSprite::SprSetTime(int nIndex, DWORD dwTime)
{
	SPR *set = m_pSpr->next;
	int i;

	if (nIndex >= m_sprInfo.nSprCount)
		return FALSE;

	//  ε 带 ã´.
	for (i = 0; i < nIndex; i++)
	{
		set = set->next;
	}

	// 
	set->dwTime = dwTime;

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ 
//-----------------------------------------------------------------------------
BOOL CSprite::SprDel(int nIndex)
{
	
	SPR *del = m_pSpr->next;		//  
	SPR *del_1 = m_pSpr->next;	//   
	int i;

	if (nIndex >= m_sprInfo.nSprCount)
		return FALSE;

	//  ε 带 ã´.
	for (i = 0; i < nIndex; i++)
	{
		del_1 = del;
		del = del->next;
	}

	// 
	del_1->next = del->next;
	delete del;

	// Ʈ īƮ 
	m_sprInfo.nSprCount--;

	return TRUE;
}



//-----------------------------------------------------------------------------
// nIndex Ʈ ͸ 
//-----------------------------------------------------------------------------
SPR* CSprite::sprGetSpr(int nIndex)
{
	int i;
	SPR *spr = m_pSpr->next;
	
	//  ó
	if (nIndex >= m_sprInfo.nSprCount)
		return FALSE;

	//  ε 带 ã´.
	for (i = 0; i < nIndex; i++)
	{
		spr = spr->next;
	}

	return spr;

}





//-----------------------------------------------------------------------------
// ִϸ̼ ߰
//-----------------------------------------------------------------------------
BOOL CSprite::AniAdd(char *strName, int nStart, int nEnd)
{
	ANI *last = m_pAni;
	ANI *add = NULL;

	// ο  
	add = new ANI;
	if (add == NULL)
		return FALSE;

	// ο 忡  
	strcpy(add->strAniName, strName);
	add->nStartIndwx = nStart;
	add->nEndIndex = nEnd;
	add->next = NULL;

	// ߰Ұ Search.. ..
	while (last->next != NULL)
		last = last->next;

	// ߰
	last->next = add;

	// ִ īƮ 
	m_sprInfo.nAniCount++;

	return TRUE;
}



//-----------------------------------------------------------------------------
// ִϸ̼ 
//-----------------------------------------------------------------------------
BOOL CSprite::AniDel(int nIndex)
{
	ANI *del = m_pAni->next;		//  
	ANI *del_1 = m_pAni;	//   
	int i;

	if (nIndex >= m_sprInfo.nAniCount)
		return FALSE;

	//  ε 带 ã´.
	for (i = 0; i < nIndex; i++)
	{
		del_1 = del;
		del = del->next;
	}

	// 
	del_1->next = del->next;
	delete del;

	// ִ īƮ 
	m_sprInfo.nAniCount--;

	return TRUE;
}



//-----------------------------------------------------------------------------
// ִϸ̼ 
//-----------------------------------------------------------------------------
BOOL CSprite::AniModify(int nIndex, char *strName, int nStart, int nEnd)
{
	int i;
	ANI *modify = m_pAni->next;

	if (nIndex >= m_sprInfo.nAniCount)
		return FALSE;

	//   Search..
	for (i = 0; i < nIndex; i++)
		modify = modify->next;

	// 
	modify->nStartIndwx = nStart;
	modify->nEndIndex = nEnd;
	strcpy(modify->strAniName, strName);

	return TRUE;
}





//-----------------------------------------------------------------------------
// nIndex ִ  
//-----------------------------------------------------------------------------
ANI* CSprite::GetAni(int nIndex)
{
	int i;

	if (nIndex >= m_sprInfo.nAniCount)
		return NULL;

	ANI *ani = m_pAni->next;

	for (i = 0; i < nIndex; i++)
	{
		ani = ani->next;
	}

	return ani;
}





//-----------------------------------------------------------------------------
//  ߰
//-----------------------------------------------------------------------------
BOOL CSprite::SoundAdd(int nSprIndex, int nID)
{
	SOUND *last = m_pSound;
	SOUND *add = NULL;

	// ο  
	add = new SOUND;
	if (add == NULL)
		return FALSE;

	// ο 忡  
	add->nID = nID;
	add->nIndex = nSprIndex;
	add->next = NULL;

	// ߰Ұ Search.. ..
	while (last->next != NULL)
		last = last->next;

	// ߰
	last->next = add;

	// ִ īƮ 
	m_sprInfo.nSndCound++;

	return TRUE;
}



//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
BOOL CSprite::SoundDel(int nIndex)
{
	SOUND *del = m_pSound;		//  
	SOUND *del_1 = m_pSound;	//   
	int i;

	if (nIndex >= m_sprInfo.nSndCound)
		return FALSE;

	//  ε 带 ã´.
	for (i = 0; i < nIndex; i++)
	{
		del_1 = del;
		del = del->next;
	}

	// 
	del_1->next = del->next;
	delete del;

	// ִ īƮ 
	m_sprInfo.nSndCound--;

	return TRUE;
}



//-----------------------------------------------------------------------------
//  
//-----------------------------------------------------------------------------
BOOL CSprite::SoundModify(int nIndex, int nSprIndex, int nID)
{
	int i;
	SOUND *modify = m_pSound;

	if (nIndex >= m_sprInfo.nSndCound)
		return FALSE;

	//   Search..
	for (i = 0; i < nIndex; i++)
		modify = modify->next;

	// 
	modify->nID = nID;
	modify->nIndex = nSprIndex;

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ʈ  - Ʈ  ̸ 
//-----------------------------------------------------------------------------
void CSprite::SetBmpFileName(char *lpszFileName)
{
	strcpy(m_sprInfo.strBmpFileName, lpszFileName);
}



//-----------------------------------------------------------------------------
// Ʈ  -  
//-----------------------------------------------------------------------------
void CSprite::SetTransparentColor(DWORD dwColor)
{
	m_sprInfo.dwTransparentColor = dwColor;
}



//-----------------------------------------------------------------------------
// Ʈ  -  
//-----------------------------------------------------------------------------
void CSprite::SetSprCount(int n)
{
	m_sprInfo.nSprCount = n;
}




//-----------------------------------------------------------------------------
// Ϸ ϱ
//-----------------------------------------------------------------------------
BOOL CSprite::Save(char *filename)
{
	FILE *fp;
	SPR *save = m_pSpr;
	

	fp = fopen(filename, "wb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  
	fwrite(&m_sprInfo, sizeof(SPR_INFO), 1, fp);

	// Ʈ Ʈ 
	while (save->next != NULL)
	{
		save = save->next;
		fwrite(save, sizeof(SPR), 1, fp);
	}

	// ִϸƮ 

	//  Ʈ 

	fclose(fp);

	return TRUE;
}



//-----------------------------------------------------------------------------
// Ͽ ҷ
//-----------------------------------------------------------------------------
BOOL CSprite::Load(char *filename)
{
	FILE *fp;
	SPR spr;

	// ʱȭ
	this->Destroy();
	this->Init();
	
	//  
	fp = fopen(filename, "rb");
	if (fp == NULL)
		return FALSE;

	// Ʈ  б
	fread(&m_sprInfo, sizeof(SPR_INFO), 1, fp);

	// Ʈ Ʈ б
	for (int i = 0; i < m_sprInfo.nSprCount; i++)
	{
		fread(&spr, sizeof(SPR), 1, fp);
		SprAdd(&spr);
	}

	// ִб

	//   б

	fclose(fp);

	return TRUE;

}

