//-----------------------------------------------------------------------------
// Note : CSprite Class  
// ϸ : CSprite.h
// 2004.3.18 T?_llundiov
//-----------------------------------------------------------------------------

#ifndef _CSPRITE_H_
#define _CSPRITE_H_

#include <windows.h>

//-----------------------------------------------------------------------------

struct SPR
{
	RECT	rcSprPos;			// Ʈ ̹ ǥ
	RECT	rcSprCollision;		// 浿 ǥ
	POINT	ptSprCenterPos;		// ߽ ǥ
	DWORD	dwTime;				// ִ Ÿ
	SPR		*next;
};

struct ANI
{
	char	strAniName[MAX_PATH];	// ִ ̸
	int		nStartIndwx;			//  ε
	int		nEndIndex;				//  ε
	ANI		*next;
};

struct SOUND
{
	int		nIndex;		// Ʈ ε
	int		nID;		//  ID
	SOUND	*next;
};

struct SPR_INFO
{
	char	strBmpFileName[MAX_PATH];	// Ʈ  ̸
	int		nSprCount;					// Ʈ 
	int		nAniCount;					// ִϸ̼ 
	int		nSndCound;					//  
	DWORD	dwTransparentColor;			// Ʈ 
};

struct ONLY_SPRITE
{
	SPR_INFO sprInfo;
	SPR		*pSpr;
};




//-----------------------------------------------------------------------------

class CSprite
{
	private:
		SPR			*m_pSpr;	// Ʈ
		ANI			*m_pAni;	// ִϸ̼
		SOUND		*m_pSound;	// 
		SPR_INFO	 m_sprInfo;	// Ʈ 

		BOOL		bReady;			// غ񿩺

	public:
		//  / Ҹ
		CSprite();
		~CSprite();

		// ʱȭ(غ۾ Ҵ)
		BOOL Init();

		// ĶƮ 
		BOOL SprAdd(RECT *rtPos, RECT *rtCol = NULL, POINT *ptCenter = NULL, DWORD dwTime = 0);
		BOOL SprAdd(SPR *spr);
		BOOL SprSetCol(int nIndex, RECT *rtCol);
		BOOL SprSetCenter(int nIndex, POINT* ptCenter);
		BOOL SprSetTime(int nIndex, DWORD dwTime);
		BOOL SprDel(int nIndex);
		SPR* sprGetSpr() { return m_pSpr; }
		SPR* sprGetSpr(int nIndex);

		// ִϸ̼ 
		BOOL AniAdd(char *strName, int nStart, int nEnd);
		BOOL AniDel(int nIndex);
		BOOL AniModify(int nIndex, char *strName, int nStart, int nEnd);

		//  
		BOOL SoundAdd(int nSprIndex, int nID);
		BOOL SoundDel(int nIndex);
		BOOL SoundModify(int nIndex, int nSprIndex, int nID);

		// Ʈ  
		void SetBmpFileName(char *lpszFileName);		// Ʈ  ̸ 
		void SetTransparentColor(DWORD dwColor);		//  
		void SetSprCount(int n);						// Ʈ  

		// ζ Լ
		const char* GetBmpFileName() const { return m_sprInfo.strBmpFileName; }
		int	GetSprCount() const { return m_sprInfo.nSprCount; }
		int	GetAniCount() const { return m_sprInfo.nAniCount; }
		int	GetSndCount() const { return m_sprInfo.nSndCound; }
		DWORD GetTransparentColor() const { return m_sprInfo.dwTransparentColor; }
		ANI* GetAni() { return m_pAni; }
		ANI* GetAni(int nIndex);

		// İ( Ҵ  ۾)
		void Destroy();

		//  & ̺  Լ
		BOOL Save(char *filename);
		BOOL Load(char *filename);

		//  Լ Ǽ..Ѥ^
		friend LRESULT CALLBACK SpriteProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam);
		friend BOOL CALLBACK ColDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam);
};

//-----------------------------------------------------------------------------

#endif // CSprite.h

