# -*- coding: cp949 -*-
import os
import posixpath
import urllib
import mimetypes
import shutil

class BasicWebServerApp:

    def __init__(self, root=None):
        if not root:
            root = os.getcwd()
        self.root = root

    def viewPath(self,path,response,env):
        """
        path Ѿ   ڵ response ѱų,
          404 status .
        """
        path = self.translatePath(path)

        if os.path.isdir(path):
            for index in "index.html", "index.htm":
                index = os.path.join(path, index)
                if os.path.exists(index):
                    path = index
                    break
            else:
                return self.listDirectory(path)

        ctype = self.guessType(path)

        f = None
        
        #if ctype.startswith('text/'):
        #    mode = 'r'
        #else:
        #    mode = 'rb'
            
        try:
            f = open(path, 'rb')
        except IOError:
            return 404

        print "\nopened %s\n" % path
        response.header["Content-type"] = ctype
        response.header["Content-Length"] = str(os.fstat(f.fileno())[6])
        response.rfile = f
        #response.send()
        #shutil.copyfileobj(f, env.request.wfile)
        return 200
        

    def listDirectory(self, path):
        return 500

    def translatePath(self, path):
        path = posixpath.normpath(urllib.unquote(path)) #ü ϴ?
        words = path.split('/')
        words = filter(None, words)
        path = self.root
        for word in words:
            drive, word = os.path.splitdrive(word)
            head, word = os.path.split(word)
            if word in (os.curdir, os.pardir): continue #. .. .
            path = os.path.join(path, word)
        return path

    def guessType(self, path):
        """Guess the type of a file.

        Argument is a PATH (a filename).

        Return value is a string of the form type/subtype,
        usable for a MIME Content-type header.

        The default implementation looks the file's extension
        up in the table self.extensions_map, using text/plain
        as a default; however it would be permissible (if
        slow) to look inside the data to make a better guess.

        """

        base, ext = posixpath.splitext(path)
        if ext in self.extensions_map:
            return self.extensions_map[ext]
        ext = ext.lower()
        if ext in self.extensions_map:
            return self.extensions_map[ext]
        else:
            return self.extensions_map['']

    extensions_map = mimetypes.types_map.copy()
    extensions_map.update({
        '': 'application/octet-stream', # Default
        '.py': 'text/plain',
        '.c': 'text/plain',
        '.h': 'text/plain',
        })
