# -*- coding: cp949 -*-
#CharonBase
#Charon Server  


__version__ = "0.1"

import socket
import sys
#import os
import threading
import time
import weakref
import mimetools
import cStringIO
import shutil
import CharonKernel

kernel = CharonKernel.CharonKernel()

class BaseStreamRequestHandler:

    rbufsize = -1
    wbufsize = 0

    def __init__(self, request, server, **kwargs):
        self.request = request
        self.server = server
        try:
            self.setup()
            if kwargs.has_key('errcode') and kwargs['errcode'] != 200:
                self.handle_error(kwargs['errcode'])
            else:
                self.handle()
            self.finish()
        finally:
            sys.exc_traceback = None    # Help garbage collection

    def setup(self):
        connection = self.request.connection
        self.rfile = connection.makefile('rb', self.rbufsize)
        self.wfile = connection.makefile('wb', self.wbufsize)

    def handle(self):
        pass

    def handle_error(self,errcode):
        pass
    
    def finish(self):
        if not self.wfile.closed:
            self.wfile.flush()
        self.wfile.close()
        self.rfile.close()
        try:
            self.request.close()
        except:
            pass

class CharonHTTPRequestHandler(BaseStreamRequestHandler):

    methodHandler = {'GET': 'doGET', 'TEST': 'doNothing'}

    def handleOne(self):
        """
          Ʈ ó.
        ù (request line)  о parseմϴ.
        parse  ޽庰  ó⸦ ȣմϴ.
        """
        #κ ù (request line) оɴϴ.
        # κп hang ߻Ҽ ֽϴ. readline()  ʿ.
        try:
            requestLine = self.rfile.readline()
        except:
            requestLine = ''

        if requestLine == '':
            return False #Connection closed?

        #chomp. request line ڿ  ǵ带 ߶ϴ.
        if requestLine[-2:] == '\r\n':
            requestLine = requestLine[:-2]
        elif requestLine[-1:] == '\n':
            requestLine = requestLine[:-1]
        self.request.requestLine = requestLine

        # Ҵ  и
        words = requestLine.split()

        if len(words) == 2 and words[0] == 'GET':
            #̰ HTTP/0.9 ƮԴϴ.
            #charon HTTP/1.1 䱸ϹǷ 505 HTTP Version Not Supported  ߻
            self.handle_error(505)
            return False
        elif len(words) != 3:
            # 
            #400 Bad Request  ߻ŵϴ.
            self.handle_error(400)
            return False
        else:
            #3 Ұ  .
            [command, path, version] = words
            self.request.command = command
            self.request.path = path
            self.request.version = version

            # üũ
            if version[:5] != 'HTTP/':
                self.handle_error(400)
                return False
            elif version != 'HTTP/1.1':
                self.handle_error(505)
                return False

            print requestLine
            # ߴٸ ùٸ HTTP 1.1 Ʈ ޾Ҵٰ մϴ.
            #  о鿩 parseմϴ.
            # blank line ϴ.  blank line Ҷ нϴ.
            
            bytes = ''
            while 1:
                line = self.rfile.readline()
                bytes = bytes + line
                print line,
                if line == '\r\n' or line == '\n' or line == '':
                    break

            # parse python  rfc2822 ޽ ؼ⿡ ñϴ.
            #ó  մϴ.
            
            hfile = cStringIO.StringIO(bytes)
            self.request.headers = mimetools.Message(hfile)

            #HTTP/1.1 Persistent Connection Support
            #HTTP/1.1  Ʈ   µ  ҽ Ʈ
            #Һ ̱  persistent connection մϴ.
            #connection: Keep-Alive  ޵    ʰ  Ʈ
            #ٸϴ.

            conntype = self.request.headers.get('connection',"")
            if conntype.lower() == 'close':
                self.closeConnection = 1
            elif conntype.lower() == 'keep-alive':
                self.closeConnection = 0

            #  ޽ ڵ鷯 ȣ.
            if self.methodHandler.has_key(command):
                method = getattr(self, self.methodHandler[command])
                method()
            else:
                #501 Unsupported Method
                self.handle_error(501)
                return False

    def handle(self):
        #Persistent Connection .
        #Connection: Keep-Alive ȿ  ϸ ݺؼ Ʈ ó

        self.closeConnection = 1

        self.handleOne()
        while not self.closeConnection:
            self.request.flush()
            self.handleOne()

    def handle_error(self,errcode):
        #ӽ  ó ƾ.
        resp = Response(errcode,self)
        resp.header['connection'] = 'close'
        resp.send()

    def doGET(self):
        #self.handle_error(404)
        resp = Response(0,self)
        status = kernel.run(self.request.path,self.request,resp)
        if status != 200:
            self.handle_error(status)
        else:
            resp.send()

    def doNothing(self):
        pass
            
       

class EchoRequestHandler(BaseStreamRequestHandler):
    def handle(self):
        requestline = self.rfile.readline()
        print "request handled : %s" % requestline # ̰  涧 Ѵ.
        self.wfile.write(requestline)

class CharonHTTPServer:
    address_family = socket.AF_INET
    socket_type = socket.SOCK_STREAM
    request_queue_size = 10 # óҶ ϴ Ʈ  ť ũ
    allow_reuse_address = True #for testing
    numMaxChildThreads = 200 #ִ   

    RequestHandlerClass = BaseStreamRequestHandler

    server_address = ('',8000) #⺻. 
    socket = None
    isActive = False

    def __init__(self, **kwargs):
        #νϽ  
        #   尡 ó Ʈ ϴ  Ű  .
        #尡 Ǹ ڵ  ش  Ʈ . - ȮѰ?
        self.child_threads = weakref.WeakKeyDictionary() 
                
        self.socket = socket.socket(self.address_family, self.socket_type)

        #μ ؼ
        for param in kwargs.keys():
            exec("self.%s = kwargs[param]" % param) #eval , exec  

        self._open()

    def __del__(self):
        #Ҹ.  Ḧ .

        #  ʴٸ ݴ´.
        try:
            self._close()
        except:
            pass
        
        
    def _open(self):
        """
        ͳ. start  ȣ,  εϰ listen.
        """
        
        if self.allow_reuse_address:
            self.socket.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.socket.bind(self.server_address)
        self.socket.listen(self.request_queue_size)
    
    def _close(self):
        """
        ͳ.    .  ٽ _open ȣɶ
         ϰ  .
        """
        self.stop() # Ʈ ó .
        self.socket.close()

    def start(self):
        """
          ¿ . stop ñ׳   ؼ Ʈ ó
        """
       
        self.isActive = True
        while self.isActive:
            self.process_request()

    def stop(self):
        """
         Ʈ ó ߴܽŴ. ׷  ȣ ΰ?
        """
        self.isActive = False

    def process_request(self):
        request = Request()
        try:
            request.connection, request.client_address = self.socket.accept()
            #Ʈ  ö .
        except socket.error:
            return
        # 带 Ͽ Ʈ óѴ.
        if len(self.child_threads) < self.numMaxChildThreads:
            th = threading.Thread(target=self.handle, args=(request,))
            th.start()
            self.child_threads[th]=request
        else:
            #尡  ִġ .
            #503 Server Busy  ߻Ų.
            self.handleError(request,503)

    def fileno(self):
        """Return socket file number.

        Interface required by select().

        """
        return self.socket.fileno()
    
    def handle(self,request):
        self.RequestHandlerClass(request, self)
        pass

    def handleError(self,request,code):
        #Ŭ̾Ʈ   ϰ  .
        self.RequestHandlerClass(request, self, errcode=code)
        pass

class Request:
    connection = None
    client_address = None

    def close(self):
        self.connection.close()

    def flush(self):
        """
        connection, client_address   νϽ  ʱȭ.
        """
        connection = self.connection
        client_address = self.client_address

        dict = self.__dict__.copy()
        
        for var in dict.keys():
            exec("del self.%s" % var)

        self.connection = connection
        self.client_address = client_address


class Response:
    code = 200
    message = None
    protocolVersion = 'HTTP/1.1'
    header = None
    content = None #̰  rfile Ѵ.
    rfile = None #ڵ, Ȥ ° Ѿ; Ѵ.
    handler = None

    def __init__(self,code,handler,**kwargs):
        self.header = {} # ü.

        self.code = code
        self.handler = handler
        
        for param in kwargs.keys():
            exec("self.%s = kwargs[param]" % param) #eval , exec  
        if not self.message:
            self.message = responses[code][0]

    def setCode(self,code):
        self.code = code
        self.message = responses[code][0]

    def send(self):
        #Response line 
        self.handler.wfile.write("%s %d %s\r\n" % (self.protocolVersion,self.code,self.message))

        # 
        for each in self.header.keys():
            self.handler.wfile.write("%s: %s\r\n" % (each, self.header[each]))
            if each.lower() == 'connection':
                if self.header[each].lower() == 'close':
                    self.handler.closeConnection = 1
                elif self.header[each].lower() == 'keep-alive':
                    self.handler.closeConnection = 0
        #   ˸
        self.handler.wfile.write("\r\n")

        if self.code >=200 and self.code not in (204,304):
            if self.content:
                self.handler.wfile.write(content)
            elif self.rfile:
                import sys
                #shutil.copyfileobj(self.rfile, sys.stdout)
                shutil.copyfileobj(self.rfile, self.handler.wfile)
                print "request fulfilled"
                #bufsize = 4096
                #print "\n\n"
                #buf = self.rfile.read(bufsize)
                #print buf,
                #self.handler.wfile.write(buf)
        


responses = {
    0: ('Not Processed',''),
    100: ('Continue', 'Request received, please continue'),
    101: ('Switching Protocols',
          'Switching to new protocol; obey Upgrade header'),
    200: ('OK', 'Request fulfilled, document follows'),
    201: ('Created', 'Document created, URL follows'),
    202: ('Accepted',
          'Request accepted, processing continues off-line'),
    203: ('Non-Authoritative Information', 'Request fulfilled from cache'),
    204: ('No response', 'Request fulfilled, nothing follows'),
    205: ('Reset Content', 'Clear input form for further input.'),
    206: ('Partial Content', 'Partial content follows.'),
    300: ('Multiple Choices',
          'Object has several resources -- see URI list'),
    301: ('Moved Permanently', 'Object moved permanently -- see URI list'),
    302: ('Found', 'Object moved temporarily -- see URI list'),
    303: ('See Other', 'Object moved -- see Method and URL list'),
    304: ('Not modified',
          'Document has not changed since given time'),
    305: ('Use Proxy',
          'You must use proxy specified in Location to access this '
          'resource.'),
    307: ('Temporary Redirect',
          'Object moved temporarily -- see URI list'),
    400: ('Bad request',
          'Bad request syntax or unsupported method'),
    401: ('Unauthorized',
          'No permission -- see authorization schemes'),
    402: ('Payment required',
          'No payment -- see charging schemes'),
    403: ('Forbidden',
          'Request forbidden -- authorization will not help'),
    404: ('Not Found', 'Nothing matches the given URI'),
    405: ('Method Not Allowed',
          'Specified method is invalid for this server.'),
    406: ('Not Acceptable', 'URI not available in preferred format.'),
    407: ('Proxy Authentication Required', 'You must authenticate with '
          'this proxy before proceeding.'),
    408: ('Request Time-out', 'Request timed out; try again later.'),
    409: ('Conflict', 'Request conflict.'),
    410: ('Gone',
          'URI no longer exists and has been permanently removed.'),
    411: ('Length Required', 'Client must specify Content-Length.'),
    412: ('Precondition Failed', 'Precondition in headers is false.'),
    413: ('Request Entity Too Large', 'Entity is too large.'),
    414: ('Request-URI Too Long', 'URI is too long.'),
    415: ('Unsupported Media Type', 'Entity body in unsupported format.'),
    416: ('Requested Range Not Satisfiable',
          'Cannot satisfy request range.'),
    417: ('Expectation Failed',
          'Expect condition could not be satisfied.'),
    500: ('Internal error', 'Server got itself in trouble'),
    501: ('Not Implemented',
          'Server does not support this operation'),
    502: ('Bad Gateway', 'Invalid responses from another server/proxy.'),
    503: ('Service temporarily overloaded',
          'The server cannot process the request due to a high load'),
    504: ('Gateway timeout',
          'The gateway server did not receive a timely response'),
    505: ('HTTP Version not supported', 'Cannot fulfill request.'),
    }

    
        
def test(ReqHandler = CharonHTTPRequestHandler):
    cs = CharonHTTPServer(RequestHandlerClass = ReqHandler)
    print "Starting CHARON server..."
    cs.start()

if __name__ == '__main__':
    test()
